
		.title	Console driver v1.09c+08 / (C)1990 ږā ,96/05/14 Ԃq.


date:		.reg	'96/05/14'
version:	.reg	'1.09c+08'
version2:	.equ	'e08 '


#symbols
# __XCONC	XCONC foCXgp
# __EMACS	EMACS ñL[ɂ
# __DEBUG	DEBUG }NLɂ

* Include File -------------------------------- *

		.include	eririn.mac
		.include	keycode.mac
		.include	doscall.mac
		.include	iocscall.mac
		.include	gm_internal.mac


* Fixed Number -------------------------------- *

WIDTH:		.equ	96
GETSMAX:	.equ	69			͂̍őoCg()
RL_PASTBUF:	.equ	general_work+GETSMAX+3	C-^,\ p̃y[Xgobt@
KBbuf_Default:	.equ	1024
BLINKCYCLE:	.equ	50
TEXTSAVESIZE:	.equ	128*16*2		*C*
IOBUFSIZE:	.equ	TEXTSAVESIZE


* Instruction Code ---------------------------- *

CTRL:		.equ	-$40
RTS:		.equ	$4e75
MOVEM:		.equ	$48e7


* I/O Address --------------------------------- *

TIMERA_VEC:	.equ	$134
CIRQ_VEC:	.equ	$138

TEXT_VRAM:	.equ	$e00000

CRTC_R21:	.equ	$e8002a
CRTC_R22:	.equ	$e8002c
CRTC_MODE:	.equ	$e80480
TEXTPAL:	.equ	$e82200

MFP_GPIP:	.equ	$e88001
MFP_DDR:	.equ	$e88005


* IOCS Work ----------------------------------- *

KBUFNUM:	.equ	$812
CSRSWITCH:	.equ	$992
TXADR:		.equ	$944
TXSTOFST:	.equ	$948
CSRXMAX:	.equ	$970
CSRX:		.equ	$974
FIRSTBYTE:	.equ	$990
TXCOLOR:	.equ	$994
TXUSEMD:	.equ	$9dd
SKEYMOD:	.equ	$bc1


* Macro --------------------------------------- *

TopChk:		.macro	areg			;Oɖ߂ꍇ
		.local	skip
		cmpa.l	(buffer_top,a6),areg
		bcc	skip
		adda.l	(buffer_size,pc),areg
skip:
		.endm

EndChk:		.macro	areg			;1bytei߂ꍇ
		.local	skip
		cmpa.l	(buffer_end,a6),areg
		bcs	skip
		movea.l	(buffer_top,a6),areg	;Ƃ
skip:
		.endm
EndChk2:	.macro	areg			;bytei߂ꍇ
		.local	skip
		cmpa.l	(buffer_end,a6),areg
		bcs	skip
		suba.l	(buffer_size,pc),areg
skip:
		.endm

GMcall:		.macro	callno
		moveq	#.low.callno,d1
		bsr	gm_tgusemd
		.endm

KEYbtst:	.macro	keyname
		btst	#keyname.and.%111,(KEYSTAT+keyname.shr.3)
		.endm
LEDbtst:	.macro	keybit
		btst	#keybit,(LEDSTAT)
		.endm
SFTbtst:	.macro	keybit
		btst	#keybit,(SFTSTAT)
		.endm

DEBUG:		.macro	char
		.ifdef	__DEBUG
		PUSH	d0-d1/a0
		moveq	#char,d1
*		IOCS	_B_PUTC
		movea.l	(b_putc_orig,pc),a0
		jsr	(a0)
		POP	d0-d1/a0
		.endif
		.endm

* Offset Table -------------------------------- *

bufstruct_size:	.equ	32
		.offset	-4
buffer_id:	.dc.l	1			'hmk*'
buffer_top:	.ds.l	1			obt@擪AhX
buffer_old:	.ds.l	1			Oobt@̈ԌÂf[^̃AhX
buffer_now:	.ds.l	1			݂̍s̐擪
buffer_write:	.ds.l	1			݃|C^
buffer_end:	.ds.l	1			obt@|C^
		.ds.l	2			gp(0)
		.fail	$.ne.(bufstruct_size-4)

		.offset	0			foCXhCoo͂̃NGXgwb_
		.ds.b	1
		.ds.b	1
DEVIO_COMMAND:	.ds.b	1
DEVIO_ERR_LOW:	.ds.b	1
DEVIO_ERR_HIGH:	.ds.b	1
		.ds.b	8
DEVIO_DATABUF:	.ds.b	1
DEVIO_ENDADR:
DEVIO_ADDRESS:	.ds.l	1
DEVIO_ARGUMENT:
DEVIO_LENGTH:	.ds.l	1
		.ds.l	1
REQHEAD_SIZE:
		.fail	REQHEAD_SIZE.ne.26

* ctype_table
IS_MULTIBYTE:	.equ	%1000_0000
IS_HEXNUMBER:	.equ	%0100_0000
IS_DECIMAL:	.equ	%0010_0000
IS_MB_bit:	.equ	7
IS_HEX_bit:	.equ	6
IS_DEC_bit:	.equ	5

		.text

* Device Driver Interface ----------------------

usereg:		.reg	d0-d1/a4-a5

top_:
		.ifdef	__XCONC
			.dc.l	xconc_header
		.else
			.dc.l	-1
		.endif
		.dc	$8020
		.dc.l	xcon_request
		.dc.l	xcon_interrupt
			*01234567
		.dc.l	'XCON    '

		.ifdef	__XCONC
xconc_header:	.dc.l	-1
		.dc	$8000
		.dc.l	xconc_request
		.dc.l	xconc_interrupt
		.dc.l	'XCONC   '

xconc_request:
		move.l	a5,(xconc_req_adr)
		rts
xconc_interrupt:
		PUSH	usereg
		movea.l	(xconc_req_adr,pc),a5
		bra	@f
		.endif

xcon_request:
		move.l	a5,(xcon_req_adr)
		rts
xcon_interrupt:
		PUSH	usereg
		movea.l	(xcon_req_adr,pc),a5
@@:
		moveq	#0,d0
		move.b	(DEVIO_COMMAND,a5),d0
		add	d0,d0
		lea	(@f,pc),a4
		adda	(a4,d0.w),a4
		moveq	#0,d0
		jsr	(a4)

		addq.l	#DEVIO_ERR_LOW,a5
		move.b	d0,(a5)+		* DEVIO_ERR_LOW
		move	d0,-(sp)
		move.b	(sp)+,(a5)		* DEVIO_ERR_HIGH

		POP	usereg
		rts

@@:		.dc	xcon_init-@b		 0F
		.dc	xcon_commanderr-@b	 1FG[
		.dc	xcon_commanderr-@b	 2Fgp
		.dc	xcon_commanderr-@b	 3FIOCTRL ɂ
		.dc	xcon_datinp-@b		 4F
		.dc	xcon_datsns-@b		 5Fǂݓ
		.dc	xcon_inpchk-@b		 6F̓Xe[^X`FbN
		.dc	xcon_commanderr-@b	 7F̓obt@NA
		.dc	xcon_output-@b		 8Fo
		.dc	xcon_output-@b		 9Fo(Verify)
		.dc	xcon_ok-@b		 0Fo̓Xe[^X`FbN
		.dc	xcon_ok-@b		11Fgp
		.dc	xcon_commanderr-@b	12FIOCTRL ɂo

xcon_datsns:
		move.b	d0,(DEVIO_DATABUF,a5)	f[^ĂĂȂ
		rts

xcon_inpchk:
		moveq	#1,d0			ɓ͕s
		rts

xcon_datinp:
		move.l	(DEVIO_LENGTH,a5),d0
		beq	xcon_ok
		movea.l	(DEVIO_ADDRESS,a5),a4
@@:
		clr.b	(a4)+
		subq.l	#1,d0
		bne	@b
xcon_ok:
*		moveq	#0,d0
		rts
xcon_commanderr:
		move	#$5003,d0		;R}hR[hs
		rts

* XCON ւ̏o
xcon_output:
usereg:		.reg	d1-d2/a0-a3
		PUSH	usereg

		moveq	#0,d0			;ESCtO/Ԓl

		move.l	(DEVIO_LENGTH,a5),d2
		beq	xcon_output_return
		subq.l	#1,d2

		movea.l	(DEVIO_ADDRESS,a5),a0
		lea	(xcon_output_hb,pc),a1
		lea	(ctype_table,pc),a2

		lea	(condrv_put_char,pc),a3
		move	(a3),-(sp)
		move	#MOVEM,(a3)

		move	(a1),d1
		bne	xcon_output_2
xcon_output_loop:
		move.b	(a0)+,d1
		tst.b	(a2,d1.w)
		bmi	xcon_output_1

***		bsr	print_d1
		jsr	(a3)			;ꕶ

		dbra	d2,xcon_output_loop
		bra	xcon_output_next

xcon_output_1:
		move.b	d1,(a1)

		dbra	d2,@f
		clr	d2
		subq.l	#1,d2
		bcs	xcon_output_end		;2bytes̓rŏI
@@:
		move	(a1),d1
xcon_output_2:
		move.b	(a0)+,d1
***		bsr	print_d1
		jsr	(a3)			;ꕶ
		moveq	#0,d1

		dbra	d2,xcon_output_loop
xcon_output_next:
		clr	d2
		subq.l	#1,d2
		bcc	xcon_output_loop

		move	d0,(a1)
xcon_output_end:
		move	(sp)+,(a3)
xcon_output_return:
		POP	usereg
		rts

		.if	0			;__DEBUG
print_d1:
		PUSH	d0-d7/a0-a6
		lea	(print_d1_buf+1,pc),a0
		moveq	#4-1,d0
print_d1_loop:
		rol	#4,d1
		moveq	#$f,d2
		and.b	d1,d2
		addi.b	#'0',d2
		cmpi.b	#'9',d2
		bls	@f
		addi.b	#'a'-('9'+1),d2
@@:
		move.b	d2,(a0)+
		dbra	d0,print_d1_loop

		lea	(print_d1_buf,pc),a1
		movea.l	(b_print_orig,pc),a0
		jsr	(a0)

		POP	d0-d7/a0-a6
		rts
print_d1_buf:
		.dc.b	'(0000)',0
		.even

		.endif

* End of Device Driver Interface ---------------

dummy_rte:
		rte

* New IOCS Call --------------------------------

iocs_b_print:
usereg		.reg	d1/a1
		PUSH	usereg
		moveq	#0,d1
		move.b	(a1)+,d1
		beq	@f			I
1:		bsr	condrv_put_char
		move.b	(a1)+,d1		̈ꕶ
		bne	1b
@@
		POP	usereg
		move.l	(b_print_orig,pc),-(sp)
		rts

iocs_txrascpy:
usereg		.reg	d1-d2/d4/a3
		PUSH	usereg
		lea	(CRTC_R21),a3
		move	(a3),d4
		move	#$010f,d0
		and.b	d3,d0
		move	d0,(a3)
		move	#$0101,d0
		tst	d3
		bpl	@f
		neg	d0			$feff
@@
		exg	d0,d2
		bsr	txrascpy_sub
		move	d4,(a3)
		POP	usereg
@@		rts

WAIT_HSYNC	.macro
		.local	skip1,skip2
skip1		tst.b	(a0)
		bmi	skip1
skip2		tst.b	(a0)
		bpl	skip2
		.endm

* in	a3.l	CRTC_R21($e8002a)

txrascpy_sub:
		subq	#1,d0			X^Rs[
		bmi	@b
usereg		.reg	d4-d6/a0-a2
		PUSH	usereg

		lea	(MFP_GPIP-CRTC_R21,a3),a0
		lea	(CRTC_R22-CRTC_R21,a3),a1
		lea	(CRTC_MODE-CRTC_R21,a3),a2

		moveq	#8,d4
		clr.b	(MFP_DDR-CRTC_R21,a3)
		bset	#0,(a3)			eLXgANZX ON
		move	sr,d5
		move	d5,d6
		ori	#$700,d6
txrascpy_loop:
		move	d6,sr			荞݋֎~
		WAIT_HSYNC

		move	d1,(a1)			]X^
		move	d4,(a2)			X^Rs[Jn
		move	d5,sr			荞݋
		add	d2,d1			̃X^
		dbra	d0,txrascpy_loop

		WAIT_HSYNC
		clr	(a2)			X^Rs[~
		bclr	#0,(a3)			eLXgANZX OFF
		POP	usereg
		rts

iocs_b_putc:
		move.l	(b_putc_orig,pc),-(sp)
		bra	condrv_put_char

* End of New IOCS Call ----------------------- *

;L̏AhXe[uLqp}N

DCR:		.macro	num,addr
		.rept	num
		.dc	addr-$
		.endm
		.endm

* obt@݃[` ------------------- *

condrv_put_char:

usereg:		.reg	d0-d7/a0-a6
		PUSH	usereg
*		rts				;obt@荞ݒ~

		cmpi.b	#ESC,d0
		bne	@f
		move.b	(option_ne_flag,pc),d0
		bne	putbuf_cansel		;ESCV[PX
@@:
		bsr	check_backscroll_buffer

		movem.l	(a6),a1-a5
		move.b	(putbuf_column,pc),d0	;ݍš
		move.b	(a3),d2			;V	 oCg
		moveq	#0,d3			;temp
		move.l	(line_buf,pc),d7

		move	d1,-(sp)
		move.b	(sp)+,d4		;byte
		beq	putbuf_1byte
		cmpi.b	#$f0,d4
		bcc	putbuf_2byte_hankaku
		cmpi.b	#$80,d4
		bne	putbuf_2byte_zenkaku

putbuf_2byte_hankaku:
		subq.b	#1,d0
		bcc	putbuf_2byte

		moveq	#WIDTH-1,d0
		bra	@f

putbuf_2byte_zenkaku:
		subq.b	#2,d0
		bcc	putbuf_2byte

		moveq	#WIDTH-2,d0
@@:		bsr	make_newline_n
putbuf_2byte:
		move.b	d4,(a4)+		;byte
		bsr	PointerForward

		move.b	d1,(a4)+		;byte
		bsr	PointerForward

		addq.b	#2,d2
		bra	putbuf_end

putbuf_1byte:
		cmpi	#$20,d1
		bcs	putbuf_ctrl0~1f		;$00`$1f
		cmpi	#DEL,d1
		bne	putbuf_hankaku		;$20-$7e
;putbuf_del:
		move.b	(option_nc_flag,pc),d4
		bne	putbuf_cansel
putbuf_bs:
putbuf_esc:
putbuf_ctrl:
putbuf_hankaku:
		subq.b	#1,d0
		bcc	@f

		moveq	#WIDTH-1,d0
		bsr	make_newline_n
@@:
		move.b	d1,(a4)+
		bsr	PointerForward

		addq.b	#1,d2
putbuf_end:
		move.b	d0,(putbuf_column)	;obt@

		move.b	d2,(a3)			;obt@oCg
		clr.b	(a4)

		movem.l	a2-a4,(4,a6)
putbuf_nul:
putbuf_esc_ne:
putbuf_ctrl_nc:
putbuf_cansel:
		POP	usereg
		move	d1,(bufwrite_last)
		rts

;s

make_newline:
		moveq	#WIDTH,d0
make_newline_n:
		move.b	d2,(a3)
		move.b	d2,(a4)+
		bsr	PointerForward

		moveq	#0,d2

		movea.l	a4,a3
		clr.b	(a4)+
		bra	PointerForward

PointerForward:
		cmpa.l	a5,a4
		bne	@f
		movea.l	a1,a4
@@:
		cmpa.l	a4,a2
		bne	PointerForward_end

		addq.l	#1,a2
		cmpa.l	a5,a2
		bne	@f
		movea.l	a1,a2
@@:
		cmpa.l	d7,a2
		bne	@f
		st	(line_buf)
@@:
		move.b	(a2)+,d3
		adda	d3,a2
		cmpa.l	a5,a2
		bcs	@f
		suba.l	(buffer_size,pc),a2
@@:
		clr.b	(a2)
PointerForward_end:
		rts

;L̏

putbuf_lf:
		moveq	#CR,d1
putbuf_cr:
		cmp	(bufwrite_last,pc),d1
		beq	putbuf_cansel		;O CR 疳

		tst.b	d0
		bne	@f

		bsr	make_newline_n		;d0͕sv
@@:
		move.b	d1,(a4)+
		bsr	PointerForward

		addq.b	#1,d2

		bsr	make_newline
		bra	putbuf_end

putbuf_tab:
		tst.b	d0
		bne	@f

		bsr	make_newline
@@:
		move.b	d1,(a4)+
		bsr	PointerForward

		subq.b	#1,d0
putbuf_tab_end:
		andi.b	#.not.7,d0
		addq.b	#1,d2
		bra	putbuf_end

putbuf_tab_nt:
		tst.b	d0
		bne	@f

		bsr	make_newline
@@:
		subq.b	#1,d0
		moveq	#%111,d5		;TAB (-nt)
		and.b	d0,d5
		add.b	d5,d2

		moveq	#SPACE,d1
putbuf_tab_loop:
		move.b	d1,(a4)+		;TABSPACEɕϊ
		bsr	PointerForward
		dbra	d5,putbuf_tab_loop
		bra	putbuf_tab_end

putbuf_bs_nb:
		subq.b	#1,d2			;BS (-nb)
		bmi	putbuf_cansel		;J[\s̍[ɂ

		addq.b	#1,d0
		subq.l	#1,a4
		TopChk	a4

usereg2:	.reg	d0-d1/a1-a2/a5
		PUSH	usereg2
		lea	(line_buf,pc),a2
		tst.b	(a2)
		bmi	@f

		lea	(cursorY,pc),a5
		move	(a5),d1
		lsl	#2,d1
		movea.l	(a2,d1.w),a1
		cmpa.l	a1,a3			a3=݈ʒu
		bne	@f
		move	-(a5),d1		cursorXbyte
		move	-(a5),d0		cursorX
		adda	d1,a1
		addq.l	#1,a1
		EndChk	a1
		cmpa.l	a1,a4
		bne	@f
		subq	#1,d0
		bmi	@f
		subq	#1,d1
		bmi	@f
		movem	d0-d1,(a5)
@@:
		POP	usereg2
		bra	putbuf_end

***
putbuf_ctrl0~1f:
		lea	(putbuf_ctrl_table,pc,d1.w),a0
		adda	d1,a0
		adda	(a0),a0
		jmp	(a0)

;L̏\

PUT_CTRL_LIST:	.equ	%1111_0111_1111_1111_1101_1000_1111_1110

putbuf_ctrl_table:
		DCR	 1,putbuf_nul		;$00
		DCR	 7,putbuf_ctrl		;$01`$07
		DCR	 1,putbuf_bs		;$08
		DCR	 1,putbuf_tab		;$09
		DCR	 1,putbuf_lf		;$0a
		DCR	 2,putbuf_ctrl		;$0b`$0c
		DCR	 1,putbuf_cr		;$0d
		DCR	13,putbuf_ctrl		;$0e`$1a
		DCR	 1,putbuf_esc		;$1b
		DCR	 4,putbuf_ctrl		;$1c`$1f

* New DOS Call ---------------------------------

dos_fnckey:
		pea	(display_system_status,pc)
		move.l	(fnckey_orig,pc),-(sp)
		rts

dos_hendsp:
		cmpi	#3,(a6)
		beq	dos_hendsp_close	[h\EBhEN[Y
		tst	(a6)
		bne	call_original_dos_hendsp
		bset	#FEPOPEN_bit,(bitflag)	[h\EBhEI[v
call_original_dos_hendsp:
		move.l	(hendsp_orig,pc),-(sp)
		rts

dos_hendsp_close:
		bsr	call_original_dos_hendsp
		bclr	#FEPOPEN_bit,(bitflag)	
		bra	display_system_status

dos_conctrl:
		cmpi	#$e,(a6)
		bne	call_original_dos_conctrl

		move	(2,a6),d0
		bmi	dos_conctrl_getfncmode
		bsr	set_funcdisp_flag
		bsr	call_original_dos_conctrl
display_system_status:
		move.b	(bitflag,pc),-(sp)
		andi.b	#IS_FEPOPEN.or.IS_GETSS.or.IS_NO_FUNC,(sp)+
		bne	display_sys_stat_end
		btst	#OPT_F_bit,(option_flag,pc)
		bne	display_sys_stat_end

usereg		.reg	d0-d4/a1
		PUSH	usereg
		move.b	(option_f_col,pc),d1	\
		moveq	#0,d2			[
		moveq	#31,d3			ŉs

		cmpi.b	#18,($93c)		CRTMOD
		bne	@f
		moveq	#848/16-1,d3
@@
		moveq	#2-1,d4			2
		lea	(sys_stat_prtbuf,pc),a1
		cmpi	#RTS,(condrv_put_char-sys_stat_prtbuf,a1)
		sne	(a1)
		addi.b	#'!',(a1)
		.fail	('!'-1).ne.SPACE
		IOCS	_B_PUTMES
		POP	usereg
display_sys_stat_end:
		rts

dos_conctrl_getfncmode:
		bsr	call_original_dos_conctrl
		bsr	set_funcdisp_flag
		bra	display_system_status

set_funcdisp_flag
usereg		.reg	d0-d1/a0
		PUSH	usereg
		lea	(bitflag,pc),a0
		moveq	#NO_FUNC_bit,d1

		bset	d1,(a0)
		cmpi	#2,d0
		bcc	@f		2ȉȂ\Ăǂ
		bchg	d1,(a0)
@@
		POP	usereg
		rts

call_original_dos_conctrl:
		move.l	(conctrl_orig,pc),-(sp)
		rts

* Condrv Official Work -------------------------
		.even
option_flag:
		.dc.b	0
OPT_J_bit:	.equ	7 : -j(R[h͎16î݃y[Xg)
OPT_F_bit:	.equ	0 : -f(!\Ȃ)
		.even
		.dc	0,10			y[Xg̃EFCgJE^/l(gp)
		.dc.l	condrv_system_call
		.dc.b	0
keyctrl_flag:
		.dc.b	0			-1:L[}
		.dc.l	condrv_put_char
pastbuf_size:
		.dc.l	KBbuf_Default
pastbuf_adr:
		.dc.l	keypast_buffer
		.dc.l	'hmk*'

* IOCS _KEY_INIT -------------------------------

iocs_key_init:
		move.l	(key_init_orig,pc),-(sp)
		bra	initialize_keypast_buffer

* L[obt@ ---------------------------

initialize_keypast_buffer:
		movea.l	(pastbuf_adr,pc),a0
@@:
		tst.b	(a0)+
		bne	@b

		subq.l	#1,a0
		move.l	a0,(past_pointer)
check_backscroll_buffer_end:
		rts

* obNOobt@ ---------------------

check_backscroll_buffer:
		movea.l	(backscroll_buf_adr,pc),a6
		cmpi.l	#'hmk*',(a6)+
		beq	check_backscroll_buffer_end

initialize_backscroll_buffer:
usereg:		.reg	d0/a5-a6
		PUSH	usereg
		moveq	#0,d0
		movea.l	(backscroll_buf_adr,pc),a6
		lea	(bufstruct_size,a6),a5

		move.l	#'hmk*',(a6)+
		move.l	a5,(a6)+		BufTop
		.rept	3
		move.l	a5,(a6)+		擪s/ݍs/݃|C^
		move.b	d0,(a5)+
		.endm
		subq.l	#3,a5
		adda.l	(buffer_size,pc),a5
		move.l	a5,(a6)+		BufEnd
		move.l	d0,(a6)+		gp
		move.l	d0,(a6)			V

		lea	(line_buf,pc),a5
		st	(a5)
		move	d0,(bufwrite_last-line_buf,a5)

		POP	usereg
		rts

* IOCS _B_KEYINP ------------------------------ *

iocs_b_keyinp:
		bsr	iocs_b_keysns
		tst.l	d0
		beq	iocs_b_keyinp
call_orig_b_keyinp:
		move.l	(b_keyinp_orig,pc),-(sp)
		rts

* IOCS _B_KEYSNS ------------------------------ *

__FAST_PAST:	.equ	0			* 1:64bytes]

iocs_b_keysns:
		moveq	#0,d0
		movea.l	(past_pointer,pc),a0
		move.b	(a0)+,d0
		beq	not_past_mode

		KEYbtst	KEY_ESC
		bne	past_stop		* ESC Ăy[Xg𒆎~

		tst	(KBUFNUM)
		bne	not_past_mode		* L[͂Ă

usereg:		.reg	d1-d2/a1-a3
		PUSH	usereg
		move	sr,-(sp)

		lea	(ctype_table,pc),a3
		moveq	#0,d1			ꉞNA
		moveq	#0,d2			-1:2oCg

		ori	#$700,sr
past_one_more_char:
		lea	(KBUFNUM),a2
		movea.l	(2,a2),a1
		addq.l	#2,a1
		cmpa	#$89c,a1
		bcs	@f
		lea	($81c),a1
@@:
		bclr	#AFTERCR_bit,(bitflag)
		beq	past_without_header	ʂɏo

		move.b	(option_flag,pc),d1	-j
		bpl	@f			R[h̓[hłȂ΃wb_

		LEDbtst	LED_R[h_bit
		bne	past_without_header	R[h̓[hł͏Ƀwb_o͂Ȃ
@@:
		move.b	(past_header,pc),d1
		beq	past_without_header

		move	d1,(a1)
		addq	#1,(a2)+
		move.l	a1,(a2)

		.if	__FAST_PAST
		subq.l	#1,a0
		.endif
		bra	past_char_next

past_without_header:
		move.l	a0,(past_pointer)
		move.b	(option_flag,pc),d1	-j
		bpl	@f
		LEDbtst	LED_R[h_bit
		beq	@f

		btst.b	#IS_HEX_bit,(a3,d0.w)	0-9A-Fa-fH
		beq	past_char_next
@@:
		move	d0,(a1)
		addq	#1,(a2)+
		move.l	a1,(a2)

		tst.b	(a3,d0.w)
		bpl	@f			1oCgH
		tst	d2
		bne	past_char_next

		moveq	#-1,d2
		move.b	(a0)+,d0		QoCgڂ
		bne	past_one_more_char
		bra	past_char_end
@@:
		cmpi.b	#CR,d0
		bne	past_char_next
		bset	#AFTERCR_bit,(bitflag)
past_char_next:
		.if	__FAST_PAST

		cmpi	#64-1,-(a2)		* Cɓ]Ǝ肱ڂH
		bhi	@f			* obt@t

		move.b	(a0)+,d0		̕
		bne	past_one_more_char
@@:
		.endif
past_char_end:
		move	(sp)+,sr
		POP	usereg			* y[XgL[`FbN͕sv
call_orig_b_keysns:
		move.l	(b_keysns_orig,pc),-(sp)
		rts

not_past_mode:
		bsr	call_orig_b_keysns

usereg:		.reg	d1-d7/a0-a6
		PUSH	usereg
		btst	#BACKSCR_bit,(bitflag,pc)
		bne	iocs_keysns_return

		move	d0,-(sp)
		move.b	(sp)+,d1
		beq	iocs_keysns_return
		move.b	(keyctrl_flag,pc),d2
		bne	iocs_keysns_return

		lea	(SFTSTAT),a0
		btst	#SFT_CTRL_bit,(a0)
		beq	@f

KEYCHK:		.macro	keycode,address
		cmpi.b	#keycode,d1
		beq	address
		.endm

		KEYCHK	KEY_4   ,direct_key_past
		KEYCHK	KEY_HELP,direct_key_past
		KEYCHK	KEY_BS  ,direct_key_toggle
		KEYCHK	KEY_CLR ,direct_key_clear

		KEYCHK	KEY_1,direct_key_backscroll_1
		KEYCHK	KEY_2,direct_key_backscroll_2
@@:
		move.b	(option_o_flag,pc),d2
		btst	d2,(a0)
		beq	iocs_keysns_return

		KEYCHK	KEY_  ,direct_key_backscroll_2
		KEYCHK	KEY_  ,direct_key_backscroll_1
		KEYCHK	KEY_UNDO,direct_key_backscroll_1
@@:
		btst	#SUSPEND_bit,(bitflag,pc)
		beq	iocs_keysns_return

* obNOJ܂܏IꍇɗLȃL[
		KEYCHK	KEY_    ,direct_key_left
		KEYCHK	KEY_    ,direct_key_right
		KEYCHK	KEY_R_DOWN,direct_key_rolldown
		KEYCHK	KEY_R_UP  ,direct_key_rollup
iocs_keysns_return:
		POP	usereg
		rts

iocs_keysns_flush:
		bsr	call_orig_b_keyinp
iocs_keysns_return_0:
		moveq	#0,d0
		bra	iocs_keysns_return

* ccrZ=1ŃeLXggp
is_text_used:
		cmpi.b	#2,(TXUSEMD)		;eLXgʂ̎gp[h
		bne	@f
		btst	#2,(option_m_flag,pc)
@@:		rts

* y[Xg𒆎~
past_stop:
		bsr	initialize_keypast_buffer
@@:
		KEYbtst	KEY_ESC
		bne	@b			;ESC܂ő҂
keybuf_clear:
		moveq	#0,d0
		lea	(KBUFNUM),a0
		move	d0,(a0)+
		move.l	(a0)+,(a0)
		rts				;0Ԃ

* ^4 , ^HELP : Jbg̈y[Xg
direct_key_past:
		bsr	yank_sub
		bsr	wait_release_ctrl_key
		bra	iocs_keysns_flush

* ^BS : obt@荞ݒf/ĊJ
direct_key_toggle:
		bsr	key_toggle_buffering_mode
		bra	iocs_keysns_flush

* ~ROLL DOWN : EBhEʒuグ
direct_key_rolldown:
		bsr	is_text_used
		beq	@f

		bsr	key_slide_window_up
@@:
		bra	iocs_keysns_flush

* ~ROLL UP : EBhEʒu
direct_key_rollup:
		bsr	is_text_used
		beq	@f

		bsr	key_slide_window_down
@@:
		bra	iocs_keysns_flush

* ~ : XN[Abv
direct_key_left:
		bsr	is_text_used
		beq	@f

		bsr	direct_key_rl_sub
		bsr	key_move_window_up
@@:
		bra	iocs_keysns_flush

* ~ : XN[_E
direct_key_right:
		bsr	is_text_used
		beq	@f

		bsr	direct_key_rl_sub
		bsr	key_move_window_down
@@:
		bra	iocs_keysns_flush

direct_key_rl_sub:
		bsr	check_backscroll_buffer
		move	(line_buf,pc),d0
		bmi	key_beginning_of_buffer
		rts

* ^CLR : obt@
direct_key_clear:
		bsr	initialize_backscroll_buffer
		bra	iocs_keysns_flush

* \[` -----------------------------

* ws(d0.w)`
draw_line_d0:
usereg		.reg	d1/a1-a2		d0 j󂵂Ȃ
		PUSH	usereg

		lea	(line_buf,pc),a3
		moveq	#0,d1
		move	d0,d1
		lsl	#2,d1
		movea.l	(a3,d1.w),a1
		move	d0,d1
		swap	d1
		lsr.l	#5,d1
		movea.l	(text_address,pc),a2
		adda.l	d1,a2			ws̃AhX
		bsr	draw_line
		POP	usereg
		rts

draw_line:
usereg		.reg	d0-d5/a0-a2/a4-a5
		PUSH	usereg
		move.l	a1,d0
		bpl	@f
		lea	(nul_string,pc),a1
@@
		.ifndef	__EMACS
		lea	(line_buf,pc),a5	;}[NE̎Zo
		move	(cursorY,pc),d1
		lsl	#2,d1
		movea.l	(a5,d1.w),a4
		adda	(cursorXbyte,pc),a4
		addq.l	#1,a4
		EndChk2	a4
		movea.l	(mark_char_adr,pc),a5
		cmpa.l	a4,a5
		bcc	@f
		exg	a4,a5
@@
		.endif
		moveq	#0,d3
		move.b	(a1)+,d3
		EndChk	a1
		moveq	#0,d4
		.ifdef	__EMACS
			moveq	#0,d5
		.endif
		bra	draw_line_

draw_line_loop:
		.ifndef	__EMACS
		move.l	(mark_char_adr,pc),d5
		beq	draw_line_nomark
		moveq	#0,d5
		cmpa.l	(buffer_old,a6),a4
		bcc	@f
		cmpa.l	(buffer_old,a6),a5
		bcs	@f
		cmpa.l	a4,a1
		bcs	draw_line_mark
		cmpa.l	a5,a1
		bcs	draw_line_nomark
		bra	draw_line_mark
@@
		cmpa.l	a4,a1
		bcs	draw_line_nomark
		cmpa.l	a5,a1
		bcc	draw_line_nomark
draw_line_mark:
		moveq	#-1,d5
draw_line_nomark:
		.endif
		move.b	(a1)+,d1
		EndChk	a1
		tst.b	d1
		bpl	@f			$00-$7f
		cmpi	#$a0,d1
		bcs	draw_line_2byte		$80-$9f
		cmpi	#$e0,d1
		bcs	@f			$a0-$df
draw_line_2byte:
		lsl	#8,d1
		move.b	(a1)+,d1
		EndChk	a1
		subq	#1,d3
@@
		bsr	draw_char_d1
draw_line_:
		moveq	#0,d1
		dbra	d3,draw_line_loop

		moveq	#0,d3
		.ifndef	__EMACS
			moveq	#0,d5
		.endif
		bra	@f
draw_space_loop:
		bsr	draw_space
@@
		cmpi.b	#WIDTH,d4
		bcs	draw_space_loop
		POP	usereg
		rts

draw_space:
		addq	#1,d4
		move.b	d5,(a2)+
_offset		.set	$80
		.rept	16-1
		move.b	d5,(_offset-1,a2)
_offset		.set	_offset+$80
		.endm
		rts

draw_char_c:
usereg		.reg	d0-d7/a0-a5
		PUSH	usereg

		lea	(line_buf,pc),a3
		moveq	#0,d5
		move	d7,d2			cursorY
		lsl	#2,d2
		movea.l	(a3,d2.w),a1
		adda	d6,a1
		addq.l	#1,a1
		EndChk	a1
		moveq	#0,d2
		move	d7,d2
		swap	d2
		lsr.l	#5,d2
		movea.l	(text_address,pc),a2
		adda.l	d2,a2
		swap	d6
		adda	d6,a2
		move	d6,d4

		.ifndef	__EMACS
		move	(cursorY,pc),d1
		lsl	#2,d1
		movea.l	(a3,d1.w),a4
		adda	(cursorXbyte,pc),a4
		addq.l	#1,a4
		EndChk2	a4
		movea.l	(mark_char_adr,pc),a5
		cmpa.l	a4,a5
		bcc	@f
		exg	a4,a5
@@
		move.l	(mark_char_adr,pc),d1
		beq	draw_char_c_nomark
		cmpa.l	(buffer_old,a6),a4
		bcc	@f
		cmpa.l	(buffer_old,a6),a5
		bcs	@f
		cmpa.l	a4,a1
		bcs	draw_char_c_mark
		cmpa.l	a5,a1
		bcs	draw_char_c_nomark
		bra	draw_char_c_mark
@@
		cmpa.l	a4,a1
		bcs	draw_char_c_nomark
		cmpa.l	a5,a1
		bcc	draw_char_c_nomark
draw_char_c_mark:
		moveq	#-1,d5			]
draw_char_c_nomark:
		.endif

		moveq	#0,d1
		move.b	(a1)+,d1
		bpl	@f
		cmpi	#$a0,d1
		bcs	draw_char_c_2byte
		cmpi	#$e0,d1
		bcs	@f
draw_char_c_2byte:
		EndChk	a1			;ŒׂΔp̎
		lsl	#8,d1
		move.b	(a1),d1
@@
		bsr	draw_char_d1
		POP	usereg
		rts

draw_char_d1:
		cmpi	#$20,d1
		bhi	draw_char_fntadr	ʂ̕
		beq	draw_space

		cmpi	#CR,d1
		bne	is_tab

		lea	(cr_font,pc),a0
		tst.b	(option_r_flag-cr_font,a0)
		bne	draw_char_condrv_font	-r w莞͉sL\
		rts
is_tab:
		cmpi	#TAB,d1
		bne	draw_char_fntadr	̑̐R[h

		lea	(tab_font_1,pc),a0
		tst.b	(option_t_flag-tab_font_1,a0)
		beq	draw_invisible_tab
@@
		bsr	draw_char_condrv_font	-t w莞TABL\
		lea	(tab_font_2,pc),a0
		moveq	#%111,d1		8̔{J܂ŕ`
		and	d4,d1
		bne	@b
		rts
draw_invisible_tab:
		bsr	draw_space
		moveq	#%111,d1
		and	d4,d1
		bne	draw_invisible_tab
		rts

draw_char_fntadr:
		moveq	#8,d2
		movea.l	(_FNTADR*4+$400),a0
		jsr	(a0)
		movea.l	d0,a0
		tst	d1
		bne	draw_widechar		Sp
draw_char_condrv_font:
		.ifndef	__EMACS
			tst.b	d5		]H
			bne	draw_char_reverse
		.endif

		addq	#1,d4			p
		move.b	(a0)+,(a2)+
_offset		.set	$80
		.rept	16-1
		move.b	(a0)+,(_offset-1,a2)
_offset		.set	_offset+$80
		.endm
		rts

draw_widechar:
		.ifndef	__EMACS
			tst.b	d5
			bne	draw_widechar_reverse
		.endif

		addq	#2,d4			Sp
		move.b	(a0)+,(a2)+
		move.b	(a0)+,(a2)+
_offset		.set	$80
		.rept	16-1
		move.b	(a0)+,(_offset-2,a2)
		move.b	(a0)+,(_offset-1,a2)
_offset		.set	_offset+$80
		.endm
		rts

		.ifndef	__EMACS
draw_char_reverse:
		addq	#1,d4			p]
		move.b	(a0)+,d0
		not.b	d0
		move.b	d0,(a2)+
_offset		.set	$80
		.rept	16-1
		move.b	(a0)+,d0
		not.b	d0
		move.b	d0,(_offset-1,a2)
_offset		.set	_offset+$80
		.endm
		rts

draw_widechar_reverse:
		addq	#2,d4			Sp]
		.rept	2
		move.b	(a0)+,d0
		not.b	d0
		move.b	d0,(a2)+
		.endm
_offset		.set	$80
		.rept	16-1
		move.b	(a0)+,d0
		not.b	d0
		move.b	d0,(_offset-2,a2)
		move.b	(a0)+,d0
		not.b	d0
		move.b	d0,(_offset-1,a2)
_offset		.set	_offset+$80
		.endm
		rts
		.endif

* J[\` ---------------------------------

blink_cursor:
		IOCS	_ONTIME
		move.l	d0,d2
		lea	(last_time,pc),a0
		move.l	(a0),d1
		cmp.l	d1,d2
		bcc	@f

		addi.l	#99*60*60*24,d2		24Ԍo߂ 0 ɖ߂̕␳
@@
		sub.l	d1,d2			oߎ
		moveq	#0,d1
		move.b	(cursor_blink_count,pc),d1
		cmp.l	d1,d2
		bcs	blink_cursor_end	܂ԂĂȂ

		move.l	d0,(a0)			J[\_ŎXV
		move.b	#BLINKCYCLE,(cursor_blink_count-last_time,a0)
		bra	blink_cursor_sub

clear_cursor:
		move.l	a0,-(sp)
		lea	(cursor_blink_count,pc),a0
		clr.b	(a0)+
		tst.b	(a0)			cursor_blink_state
		movea.l	(sp)+,a0
		beq	blink_cursor_end

blink_cursor_sub:
usereg		.reg	d0/a1-a2
		PUSH	usereg
		lea	(cursor_blink_state,pc),a2
		not.b	(a2)
		movea.l	(text_address,pc),a2
		adda	(cursorX,pc),a2
		moveq	#0,d0
		move	(cursorY,pc),d0
		swap	d0
		lsr.l	#5,d0
		adda.l	d0,a2
@@
		lea	(CRTC_R21),a1
		move	(a1),d0
		bclr	#0,(a1)
_offset		.set	0
		.rept	16
		not.b	(_offset,a2)
_offset		.set	_offset+$80
		.endm
		move	d0,(a1)
		POP	usereg
blink_cursor_end:
		rts

blink_cursor_direct:
		PUSH	usereg
		movea.l	(mes_end_adr,pc),a2
		bra	@b

* IOCS _B_KEYSNS ̃L[ --------------- *

* ^2 , ~ : obt@̍ŌォobNOɓ
direct_key_backscroll_2:
		bsr	is_text_used
		beq	iocs_keysns_flush

		bsr	pre_check_buffer
		bsr	end_of_buffer_sub
into_backscroll_at_top:
		lea	(cursorX,pc),a0
		clr.l	(a0)+			;J[\͍[
		move	d2,(a0)
		bpl	@f

		clr	(a0)
@@:
into_backscroll_at_last:
		bsr	open_backscroll_window
		bclr	#SUSPEND_bit,(bitflag)
		bsr	draw_backscroll

		bsr	call_orig_b_keyinp	;I[ṽL[͂
		bsr	keyinp_loop
		bsr	close_backscroll_window
		bsr	wait_release_ctrl_key
		bra	iocs_keysns_return_0

wait_release_ctrl_key:
		move.b	(option_p_flag,pc),d0
		beq	1f
		move.l	(past_pointer,pc),a0
		tst.b	(a0)
		beq	1f
@@:
		SFTbtst	SFT_CTRL_bit
		bne	@b
1:
		rts

* ^1 , ~ , ~UNDO : Ō̃J[\ʒuobNOɓ
direct_key_backscroll_1:
		bsr	is_text_used
		beq	iocs_keysns_flush

		bsr	pre_check_buffer

		move	(line_buf,pc),d0
		bmi	@f			;oĂ͈ԌÂʒu\

		bsr	reset_line_address_buf
		bra	into_backscroll_at_last
@@
		bsr	beginning_of_buffer_sub
		moveq	#0,d2
		bra	into_backscroll_at_top

pre_check_buffer:
		movea.l	(backscroll_buf_adr,pc),a6
		cmpi.l	#'hmk*',(a6)+
		bne	initialize_backscroll_buffer
		rts

end_of_buffer_sub:
		moveq	#-1,d2
		move	(window_line,pc),d1
		lea	(line_buf,pc),a3
		move	d1,d0
@@:
		move.l	d2,(a3)+		;sAhXobt@𖄂߂
		dbra	d0,@b

		movea.l	(buffer_now,a6),a0
		tst.b	(a0)
		beq	scroll_down_p_sub	;sȂO̍s܂ł\
scroll_down_loop:
		movea.l	a3,a1			;a1=Ō+1
		lea	(-4,a1),a2		;a2=Ō
		move	d1,d0
		subq	#1,d0
@@:
		move.l	-(a2),-(a1)		;ɂ炷
		dbra	d0,@b

		move.l	a0,(a2)
		addq	#1,d2
scroll_down_p_sub:
		subq.l	#1,a0
		TopChk	a0
		moveq	#0,d0
		move.b	(a0),d0
		beq	end_of_buffer_end	;O̍s͂Ȃ
		suba	d0,a0
		subq.l	#1,a0
		TopChk	a0

		cmp	d1,d2			s-1>\s-1
*		bcs	scroll_down_loop
		blt	scroll_down_loop	d2=$ffff̎JԂ
end_of_buffer_end:
		rts

reset_line_address_buf:
		movea.l	(line_buf,pc),a0
reset_line_address_buf_2:
		bsr	fill_line_address_buf
		bra	@f

beginning_of_buffer_sub:
		bsr	fill_line_address_buf
		movea.l	(buffer_old,a6),a0
		addq.l	#1,a0
set_line_address_loop:
		EndChk	a0
@@:
		moveq	#0,d0
		move.b	(a0),d0
		beq	@f

		move.l	a0,(a3)+
		adda	d0,a0
		addq.l	#1,a0
		EndChk2	a0
		tst.b	(a0)+
		dbeq	d1,set_line_address_loop
@@
		rts

fill_line_address_buf:
		moveq	#-1,d2
		move	(window_line,pc),d1
		lea	(line_buf,pc),a3
		move	d1,d0
		movea.l	a3,a1
@@
		move.l	d2,(a1)+
		dbra	d0,@b
		rts

draw_backscroll:
		lea	(line_buf,pc),a0
		movea.l	(text_address,pc),a2
		move	(window_line,pc),d2
draw_backscroll_loop:
		movea.l	(a0)+,a1
		bsr	draw_line
		lea	($800,a2),a2
		dbra	d2,draw_backscroll_loop
		rts

* obNXN[EBhE\ -------- *

open_backscroll_window:
		bsr	swap_interrupt_address
		bsr	initialize_keypast_buffer

		lea	(bitflag,pc),a1
		bset	#BACKSCR_bit,(a1)

		btst	#SUSPEND_bit,(a1)
		beq	save_text_pallete

		move.b	(gm_automask,pc),d0
		beq.s	set_text_mode

		GMcall	_GM_AUTO_ENABLE
		bra	set_text_mode

save_text_pallete:
		lea	(TEXTPAL),a0
		lea	(text_pal_buff,pc),a1
		moveq	#16/2-1,d0
@@:
		move.l	(a0)+,(a1)+		;eLXgpbgҔ
		dbra	d0,@b

		btst	#0,(option_m_flag,pc)
		beq	@f

		lea	(ms_ctrl_flag,pc),a0
		st	(a0)+
		move.b	(SKEYMOD),(a0)+		;skeymod_save
		IOCS	_MS_STAT
		move.b	d0,(a0)			;mscur_on_flag

		moveq	#0,d1
		IOCS	_SKEY_MOD		;\tgL[{[h/}EXJ[\
		IOCS	_MS_CUROF
@@:
		btst	#1,(option_m_flag,pc)
		beq	@f

		move	#0<<8+32*4,d1
		move	d1,d2			;Sʕۑ
		moveq	#%1100,d3
		IOCS	_TXRASCPY
@@:
		btst	#2,(option_m_flag,pc)
		bne	@f

		moveq	#2,d2			;eLXggp󋵂𖳎ȂȂ
		bsr	gm_tgusemd_orig		;gpɐݒ肷
@@:
set_text_mode:
		move	(text_pal_buff,pc),d1	;pbg0(Wō)
		move	(text_pal_buff+3*2,pc),d2	 3(V	 )

		lea	(general_work,pc),a1
		move.l	a1,-(sp)
		clr.l	-(sp)
		pea	(condrv_pal,pc)
		DOS	_GETENV
		lea	(3*4,sp),sp
		tst.l	d0
		bmi	@f

		lea	(ctype_table,pc),a0
		bsr	get_palette		;F
		move	d1,d2
		bsr	get_palette		;wiF
@@:
		lea	(gm_maskflag,pc),a2

		move	d1,-(sp)
		GMcall	_GM_MASK_STATE
		swap	d0
		move.b	d0,(a2)
		move	(sp)+,d1

		lea	(TEXTPAL+2*4),a1
		bsr	set_text_pallet		;%01xx

		move	d2,d1
		addq.l	#2*4,a1
		bsr	set_text_pallet		;%11xx

		bsr	clear_text_plane	;obNOʓhԂ

;[Ɖ[̉`
		movea.l	(text_address,pc),a1
		lea	(-4*128,a1),a0		;̐
		moveq	#1,d0
		add	(window_line,pc),d0
		lsl	#4,d0			;*16
		addq	#4,d0
		lsl.l	#7,d0			;*128
		adda.l	d0,a1

		moveq	#WIDTH/4-1,d0
		moveq	#-1,d1
@@
		move.l	d1,(a0)+
		move.l	d1,(a1)+
		dbra	d0,@b

		lea	(cursor_blink_count,pc),a0
		clr	(a0)+
		move	(CSRSWITCH),(a0)	;iocs_curflg
		IOCS	_OS_CUROF

		.ifdef	__EMACS
			rts
		.else
			bra	clr_ins_led
		.endif

set_text_pallet:
		.rept	4
		move	d1,(a1)+
		.endm
		rts

		.ifndef	__EMACS
restore_ins_led:
		bset	#LED_INS_bit,(LEDSTAT)
		move.b	(ins_clr_flag,pc),d0
		bne	call_iocs_ledset	* INS LED ͍ŏ_
clr_ins_led:
		bclr	#LED_INS_bit,(LEDSTAT)	* INS 
		sne	(ins_clr_flag)
call_iocs_ledset:
		IOCS	_LEDSET
		rts
		.endif

* ϐpbglo
* in	a0.l =	ctype_table
*	a1.l =	ϐ
* out	d1.w =	l
get_palette:
		moveq	#0,d0
		moveq	#0,d1
		bra	get_palette_loop
get_palette_loop_2:
		cmpi.b	#SPACE,d0
		beq	get_palette_loop
		btst	#IS_HEX_bit,(a0,d0.w)
		beq	get_palette_end
		btst	#IS_DEC_bit,(a0,d0.w)
		bne	@f
		andi.b	#$df,d0		A-Fa-f̎'9'̌ɂ炷
		subq.b	#'A'-('9'+1),d0
@@
		andi.b	#$f,d0
		lsl	#4,d1
		or	d0,d1
get_palette_loop:
		move.b	(a1)+,d0
		bne	get_palette_loop_2
		subq.l	#1,a1
get_palette_end:
		rts

* obNOʓhԂ -------------------- *

clear_text_plane:
usereg:		.reg	d0-d7/a0-a2
		PUSH	usereg

		lea	(CRTC_R21),a0
		move	(a0),-(sp)
		bclr	#0,(a0)

		movea.l	(text_address,pc),a1
		lea	($200-$400,a1),a1	;plane 3 NA
		bsr	fill_text_block_0

		adda.l	#$200-$20000,a1		;plane 2 hׂ
		moveq	#-1,d1
		bsr	fill_text_block

		move	(sp)+,(a0)

		move	(text_ras_no,pc),d1
		subi	#$0201,d1
		move	(window_line,pc),d2
		addq	#3,d2
		lsl	#2,d2
		subq	#1,d2
		moveq	#%1100,d3
		IOCS	_TXRASCPY

		POP	usereg
		rts

fill_text_block_0:
		moveq	#0,d1
fill_text_block:
	.irp	reg,d2,d3,d4,d5,d6,d7,a2
		move.l	d1,reg
	.endm
		moveq	#16-1,d0
@@:
		movem.l	d1-d7/a2,-(a1)
		dbra	d0,@b
		rts

* ȑÕbZ[W\s ------------ *
* in	a4.l	window_line

clear_text_raster_mesline:
		move	(a4),d1			;window_line
		add	-(a4),d1		;down_line
		addq	#2+1,d1
		lsl	#2,d1
		bra	clear_text_raster_m4

* ws ---------------------------- *
* in	d1.w	X^ԍ(0`255)

clear_text_raster_m4:
		moveq	#-1,d0			;mask
		moveq	#4-1,d2
		bra	clear_text_raster

* w胉X^ubN ---------------- *
* eLXgۑ[hȂ痠ʂ畜A
* in	d0.b	0:GMΉ(ɑS) -1:GMΉ(}XN)
*		eLXgۑ[horʎw̎Ӗ
*	d1.w	X^ԍ(0`255)
*	d2.w	X^-1

clear_text_raster:
usereg:		.reg	d1-d7/a0-a2
		PUSH	usereg

		tst.b	d1
		bmi	clear_text_raster_force_clear
		btst	#1,(option_m_flag,pc)
		beq	clear_text_raster_mask_clear

		move.b	d1,d0
		tas	d1			;ʂ\ɃRs[
		lsl	#8,d1
		move.b	d0,d1
		addq	#1,d2
		bra	clear_text_raster_rascpy

clear_text_raster_force_clear:
		moveq	#0,d0			;ʂmaskȂ
clear_text_raster_mask_clear:
		move.b	d1,-(sp)		;!
		move	d2,-(sp)		;!

		lea	(CRTC_R21),a0
		move	(a0),-(sp)
		move	#%1_1100_0000,(a0)

		move.b	d0,-(sp)

		addi	#($e60000+128*4)/(128*4),d1
		mulu	#128*4,d1
		movea.l	d1,a1
		bsr	fill_text_block_0	;v[2/3NA

		move.b	(sp)+,d0
		and.b	(gm_maskflag,pc),d0
		beq	clear_text_raster_copy

		clr	(a0)			;graphic mask
		moveq	#-1,d0
		moveq	#-1,d1
		moveq	#-1,d2
		moveq	#-1,d3
		moveq	#4-1,d4
@@:
		movem.l	d0-d3,(a1)
		movem.l	d0-d3,(80,a1)
		lea	(128,a1),a1
		dbra	d4,@b
clear_text_raster_copy:
		move	(sp)+,(a0)

		move	(sp)+,d2		;!
		move	(sp),d1			;!
		move.b	(sp)+,d1
		addq.b	#1,d1
clear_text_raster_rascpy:
		moveq	#%1100,d3
		IOCS	_TXRASCPY		;ɕʂ

		POP	usereg
		rts

* obNXN[ʂ -------------- *

close_backscroll_window:
		lea	(mark_char_adr,pc),a0	;}[NNA
		move.l	(a0),d3
		clr.l	(a0)+
		clr.l	(mark_line_adr-(mark_char_adr+4),a0)

		btst	#2,(option_m_flag,pc)
		bne	@f
						;eLXggp󋵂𖳎ȂȂ
		bsr	gm_tgusemd_orig_tm1	;VXeŎgpɐݒ肷
@@:
		btst	#SUSPEND_bit,(bitflag,pc)
		beq	restore_text
* ctrl-undo {
		GMcall	_GM_AUTO_STATE
		bne	@f			;풓
		swap	d0
		subq.b	#%10,d0
		seq	(gm_automask-mark_line_adr,a0)
		bne	@f			;֎~

		GMcall	_GM_AUTO_DISABLE
@@:
		.ifndef	__EMACS
		tst.l	d3
		beq	@f
		bsr	draw_backscroll		;}[NԂŕ`
@@:
		.endif
		bra	dont_restore_text
* }
restore_text:
		btst	#1,(option_m_flag,pc)
		bne	restore_text_from_backside

		moveq	#-1,d0			;mask
		move	(down_line,pc),d1
		lsl	#2,d1
		move	(window_line,pc),d2
		addq	#3,d2
		lsl	#2,d2
		subq	#1,d2
		bra	@f
restore_text_from_backside:
		move	#32*4<<8+0,d1		;-m2w莞͗TVRAMRs[
		move	#32*4,d2
		moveq	#%1100,d3
		IOCS	_TXRASCPY

		moveq	#0,d0
		move	#32*4,d1
		moveq	#32*4-1,d2
@@:
		bsr	clear_text_raster	;\orʏ

		lea	(ms_ctrl_flag,pc),a0
		tst.b	(a0)
		beq	mouse_ctrl_off

		clr.b	(a0)+

		moveq	#0,d1
		move.b	(a0)+,d1		;skeymod_save
		IOCS	_SKEY_MOD		;\tgL[{[h̏Ԃ߂

		tst.b	d1
		bmi	@f
		tst.b	(a0)			;mscur_on_flag
		beq	@f

		IOCS	_MS_CURON
@@:
mouse_ctrl_off:
		lea	(text_pal_buff,pc),a0
		lea	(TEXTPAL),a1
		moveq	#16/2-1,d0
@@:
		move.l	(a0)+,(a1)+
		dbra	d0,@b

		move.b	(gm_maskflag,pc),d0
		beq	@f

		GMcall	_GM_MASK_SET
@@:
dont_restore_text:
		.ifndef	__EMACS
			bsr	restore_ins_led
		.endif
		lea	(iocs_curflg,pc),a0
		move	(a0),(CSRSWITCH)
		bclr	#BACKSCR_bit,(bitflag-iocs_curflg,a0)

		bra	swap_interrupt_address

swap_interrupt_address:
		lea	(TIMERA_VEC),a0
		lea	(vdisp_int_adr,pc),a1	;荞݂ŃtbNAhX
		bsr	swap_interrupt_address_sub

		lea	(CIRQ_VEC),a0
		lea	(ras_int_adr,pc),a1	;X^荞݂ŃtbNAhX
swap_interrupt_address_sub:
		move.l	(a1),d0
		beq	@f			ɂȂ

		move.l	(a0),(a1)
		move.l	d0,(a0)
@@:		rts

* obNÕL[̓Tu[` -----------

keyinp_loop:
		bsr	blink_cursor
		bsr	call_orig_b_keysns
		tst.l	d0
		beq	keyinp_loop

		cmpi	#KEY_SHIFT.shl.8,d0	G[bZ[W\Ă
		bcc	@f			̃L[͂ꂽɏ
		move.l	(mes_end_adr,pc),d0
		beq	@f
		bsr	clear_message
@@
		pea	(keyinp_loop,pc)	Ȍ̓[v鎞 rts
		bsr	call_orig_b_keyinp

		move	d0,-(sp)		L[obt@܂ĂȂׂ
		bsr	call_orig_b_keysns
		move	(sp),d1
		cmp	d0,d1
		bne	@f			ႤL[ĂꍇOK

		lsr	#8,d1
		move	d1,d0
		lsr	#3,d0
		lea	(KEYSTAT),a0
		adda	d0,a0
		btst	d1,(a0)
		bne	@f			L[܂Ă

		bsr	keybuf_clear
@@
		.ifdef	__EMACS

PREFIX_ESC:	.equ	7
PREFIX_CTRL_X:	.equ	6

keyinp_direct:
		move	(sp)+,d0
		move.b	($80e),d0
		lea	(prefix_flag,pc),a0
		or.b	(a0),d0
		KEYbtst	KEY_XF3
		beq	@f
		tas	d0		*	bset	#PREFIX_ESC,d0
@@:
		rol	#8,d0
*		cmpi.b	#KEY_SHIFT,d0
		cmpi.b	#$6d,d0
		bcc	keycheck_end		;shift/ctrl/opt.1&2 or ͖
		cmpi.b	#KEY_BREAK,d0
		bcc	@f
		cmpi.b	#KEY_XF1,d0
		bcc	keycheck_end		;xf1`5/LEDL[͖
@@:
		clr.b	(a0)

		lea	(emacs_key_table,pc),a0
		bsr	keycheck		;braɂȂ!
keycheck_end:
		rts

		.else

		moveq	#0,d0
		move.b	(sp)+,d0
		move.b	(option_o_flag,pc),d1	0:Shift 1:CTRL 2:OPT.1 3:OPT.2
		btst	d1,(SFTSTAT)
		beq	is_key_ctrl
* OPT.1n
		lea	(opt_key_table,pc),a0
		bsr	keycheck
		move.b	(option_o_flag,pc),d1
		subq.b	#2,d1
		bcc	keycheck_end		-o1,2 ȂI
is_key_ctrl:
		SFTbtst	SFT_CTRL_bit
		bne	check_ctrl_key
* VtgnȂ
		lea	(nomal_key_table,pc),a0
		SFTbtst	SFT_SHIFT_bit
		beq	@f
* Shiftn
		lea	(shift_key_table,pc),a0
		bra	@f
* CTRLn
check_ctrl_key:
		lea	(ctrl_key_table,pc),a0
		bsr	keycheck
		lea	(ctrl_key_table_2,pc),a0
@@
		bsr	keycheck		Kbsr
keycheck_end:
		rts

		.endif
* ʕ {

keycheck:
		move	(a0)+,d1		address
		.ifdef	__EMACS
			beq	visual_bell
		.else
			beq	keycheck_end
		.endif
		cmp	(a0)+,d0		keycode
		bne	keycheck
		adda	d1,a0
		move.l	a0,(sp)			ĂяoƂɂ͖߂ȂĂ悢
		bra	clear_cursor

KEYTBL:		.macro	keycode,address
		.dc	address-($+4),keycode
		.endm
KEYTBL_END:	.macro
		.dc	0
		.endm

* }
		.ifdef	__EMACS

* META  C-x  0  0  | OPT.2  OPT.1  CTRL  SHIFT

emacs_key_table:
		KEYTBL	KEY_ESC		,key_prefix_meta
		KEYTBL	KEY_HELP	,key_help
		KEYTBL	KEY_HOME	,key_kill_condrv
		KEYTBL	KEY_UNDO	,key_kill_condrv
		KEYTBL	KEY_Q		,key_kill_condrv
		KEYTBL	KEY_		,key_backward_char
		KEYTBL	KEY_B		,key_backward_char
		KEYTBL	KEY_		,key_forward_char
		KEYTBL	KEY_F		,key_forward_char
		KEYTBL	KEY_		,key_previous_line
		KEYTBL	KEY_P		,key_previous_line
		KEYTBL	KEY_		,key_next_line
		KEYTBL	KEY_N		,key_next_line
		KEYTBL	KEY_R_DOWN	,key_scroll_down
		KEYTBL	KEY_R_UP	,key_scroll_up
		KEYTBL	KEY_DEL		,key_kill_region
		KEYTBL	KEY_CR		,key_yank_current_word
		KEYTBL	KEY_K		,key_yank_to_end_of_line
		KEYTBL	KEY_U		,key_yank_from_beginning_of_line
		KEYTBL	KEY_TAB		,key_toggle_past_header_tab
		KEYTBL	KEY_F		,key_toggle_past_header_colon
		KEYTBL	KEY_|		,key_toggle_past_header_hyphen
###		KEYTBL	KEY_L		,key_set_label
		KEYTBL	KEY_F0		,key_beginning_of_buffer
		KEYTBL	KEY_F1		,key_end_of_buffer
		KEYTBL	KEY_^		,key_search_forward
		KEYTBL	KEY_F3		,key_search_forward
		KEYTBL	KEY_F4		,key_search_forward_next
SHIFT:		.equ	%0000_0001.shl.8
		KEYTBL	SHIFT+KEY_T	,key_beginning_of_page
		KEYTBL	SHIFT+KEY_B	,key_end_of_page
		KEYTBL	SHIFT+KEY_	,key_toggle_past_header_bracket
###		KEYTBL	SHIFT+KEY_7	,key_jump_label
		KEYTBL	SHIFT+KEY_^	,key_search_backward
		KEYTBL	SHIFT+KEY_F3	,key_search_backward
		KEYTBL	SHIFT+KEY_F4	,key_search_backward_next
		KEYTBL	SHIFT+KEY_N	,key_search_backward_next
CTRL_:		.equ	%0000_0010.shl.8
		KEYTBL	CTRL_+KEY_X	,key_prefix_ctrl_x
		KEYTBL	CTRL_+KEY_Z	,key_suspend_condrv
		KEYTBL	CTRL_+KEY_UNDO	,key_suspend_condrv
		KEYTBL	CTRL_+KEY_B	,key_backward_char
		KEYTBL	CTRL_+KEY_F	,key_forward_char
		KEYTBL	CTRL_+KEY_P	,key_previous_line
		KEYTBL	CTRL_+KEY_N	,key_next_line
		KEYTBL	CTRL_+KEY_A	,key_beginning_of_line
		KEYTBL	CTRL_+KEY_E	,key_end_of_line
		KEYTBL	CTRL_+KEY_R_DOWN,key_beginning_of_buffer_mark
		KEYTBL	CTRL_+KEY_R_UP	,key_end_of_buffer_mark
		KEYTBL	CTRL_+KEY_V	,key_scroll_up
		KEYTBL	CTRL_+KEY_SPACE	,key_set_mark
		KEYTBL	CTRL_+KEY_W	,key_kill_region
		KEYTBL	CTRL_+KEY_Y	,key_yank_region
		KEYTBL	CTRL_+KEY_	,key_shrink_window
		KEYTBL	CTRL_+KEY_	,key_grow_window
		KEYTBL	CTRL_+KEY_	,key_move_window_up
		KEYTBL	CTRL_+KEY_	,key_move_window_down
		KEYTBL	CTRL_+KEY_K	,key_kill_to_end_of_line
		KEYTBL	CTRL_+KEY_U	,key_kill_from_beginning_of_line
		KEYTBL	CTRL_+KEY_S	,key_isearch_forward		쐬
		KEYTBL	CTRL_+KEY_R	,key_isearch_backward		  V
		KEYTBL	CTRL_+KEY_N	,key_search_backward_next
		KEYTBL	CTRL_+KEY_O	,key_search_forward_current_word
		KEYTBL	CTRL_+KEY__	,key_search_backward_current_word
		KEYTBL	CTRL_+KEY_I	,key_toggle_past_header_tab
		KEYTBL	CTRL_+KEY_BS	,key_toggle_buffering_mode
		KEYTBL	CTRL_+KEY_CLR	,key_clear_buffer
C_X:		.equ	%0100_0000.shl.8
		KEYTBL	C_X+KEY_I	,key_insert_file
		KEYTBL	C_X+KEY_W	,key_write_file
		KEYTBL	C_X+KEY_Z	,key_grow_window
		KEYTBL	C_X+KEY_M	,key_toggle_buffer_mode
C_X_CTRL:	.equ	C_X+CTRL_
		KEYTBL	C_X_CTRL+KEY_C	,key_kill_condrv
		KEYTBL	C_X_CTRL+KEY_Z	,key_shrink_window
		KEYTBL	C_X_CTRL+KEY_P	,key_move_window_up
		KEYTBL	C_X_CTRL+KEY_N	,key_move_window_down
		KEYTBL	C_X_CTRL+KEY_X	,key_exchange_point_and_mark
		KEYTBL	C_X_CTRL+KEY_S	,key_search_forward
		KEYTBL	C_X_CTRL+KEY_R	,key_search_backward
		KEYTBL	C_X_CTRL+KEY_M	,key_toggle_text_mode
META:		.equ	%1000_0000.shl.8
		KEYTBL	META+KEY_ESC	,key_prefix_meta_cancel
		KEYTBL	META+KEY_SPACE	,key_set_mark
		KEYTBL	META+KEY_D	,key_set_mark
		KEYTBL	META+KEY_Q	,key_kill_condrv
		KEYTBL	META+KEY_B	,key_backward_word
		KEYTBL	META+KEY_F	,key_forward_word
		KEYTBL	META+KEY_V	,key_scroll_down
		KEYTBL	META+KEY_W	,key_copy_region
		KEYTBL	META+KEY_R_DOWN	,key_slide_window_up
		KEYTBL	META+KEY_R_UP	,key_slide_window_down
		KEYTBL	META+KEY_N	,key_search_forward_next
S_META:		.equ	SHIFT+META
		KEYTBL	S_META+KEY_H	,key_help
		KEYTBL	S_META+KEY_	,key_beginning_of_buffer_mark
		KEYTBL	S_META+KEY_	,key_end_of_buffer_mark
		KEYTBL_END

key_prefix_meta:
		lea	(prefix_meta_mes,pc),a1
		moveq	#PREFIX_ESC,d0
		bra	@f
key_prefix_ctrl_x:
		lea	(prefix_ctrlx_mes,pc),a1
		moveq	#PREFIX_CTRL_X,d0
@@
		bsr	print_message
		lea	(prefix_flag,pc),a0
		bset	d0,(a0)
key_prefix_meta_cancel:
		rts

		.else
nomal_key_table:
		KEYTBL	KEY_ESC		,key_kill_condrv
		KEYTBL	KEY_HOME	,key_kill_condrv
		KEYTBL	KEY_UNDO	,key_kill_region
		KEYTBL	KEY_R_UP	,key_scroll_up
		KEYTBL	KEY_R_DOWN	,key_scroll_down
		KEYTBL	KEY_A		,key_backward_word
		KEYTBL	KEY_F		,key_forward_word
		KEYTBL	KEY_		,key_previous_line
		KEYTBL	KEY_		,key_next_line
		KEYTBL	KEY_		,key_backward_char
		KEYTBL	KEY_		,key_forward_char
		KEYTBL	KEY_M		,key_mark_change_led
		KEYTBL	KEY_INS		,key_mark_dont_change_led
		KEYTBL	KEY_K		,key_yank_to_end_of_line
		KEYTBL	KEY_O		,key_kill_region
		KEYTBL	KEY_DEL		,key_kill_region
		KEYTBL	KEY_CR		,key_yank
		KEYTBL	KEY_ENTER	,key_yank
		KEYTBL	KEY_U		,key_yank_from_beginning_of_line
		KEYTBL	KEY_^		,key_search_forward
		KEYTBL	KEY_F3		,key_search_forward
		KEYTBL	KEY_N		,key_search_forward_next
		KEYTBL	KEY_F4		,key_search_forward_next
		KEYTBL	KEY_HELP	,key_help
		KEYTBL	KEY_F		,key_toggle_past_header_colon
		KEYTBL	KEY_|		,key_toggle_past_header_hyphen
		KEYTBL	KEY_TAB		,key_toggle_past_header_tab
		KEYTBL	KEY_T		,key_beginning_of_buffer
		KEYTBL	KEY_F0		,key_beginning_of_buffer
		KEYTBL	KEY_B		,key_end_of_buffer
		KEYTBL	KEY_F1		,key_end_of_buffer
		KEYTBL	KEY_L		,key_set_label
		KEYTBL	KEY_Q		,key_toggle_buffer_mode
*		KEYTBL_END
ctrl_key_table_2:				* CTRL ĂȂĂ
		KEYTBL	KEY_W		,key_move_window_up
		KEYTBL	KEY_Z		,key_move_window_down
		KEYTBL	KEY_E		,key_previous_line
		KEYTBL	KEY_X		,key_next_line
		KEYTBL	KEY_D		,key_forward_char
		KEYTBL	KEY_S		,key_backward_char
		KEYTBL	KEY_P		,key_yank
		KEYTBL_END
opt_key_table:
		KEYTBL	KEY_		,key_move_window_up
		KEYTBL	KEY_		,key_move_window_down
		KEYTBL	KEY_UNDO	,key_suspend_condrv
		KEYTBL	KEY_R_UP	,key_slide_window_down
		KEYTBL	KEY_R_DOWN	,key_slide_window_up
		KEYTBL	KEY_		,key_shrink_window
		KEYTBL	KEY_		,key_grow_window
		KEYTBL_END
ctrl_key_table:
		KEYTBL	KEY_m		,key_kill_condrv
		KEYTBL	KEY_R		,key_scroll_down
		KEYTBL	KEY_C		,key_scroll_up
		KEYTBL	KEY_T		,key_beginning_of_page
		KEYTBL	KEY_B		,key_end_of_page
		KEYTBL	KEY_A		,key_beginning_of_line
		KEYTBL	KEY_F		,key_end_of_line
		KEYTBL	KEY_K		,key_kill_to_end_of_line
		KEYTBL	KEY_U		,key_kill_from_beginning_of_line
		KEYTBL	KEY_N		,key_search_backward_next
		KEYTBL	KEY_		,key_write_file
		KEYTBL	KEY_J		,key_help
		KEYTBL	KEY_n		,key_help
		KEYTBL	KEY_I		,key_toggle_past_header_tab
		KEYTBL	KEY_Y		,key_insert_file
		KEYTBL	KEY_Q		,key_toggle_text_mode
		KEYTBL	KEY_O		,key_search_forward_current_word
		KEYTBL	KEY__		,key_search_backward_current_word
		KEYTBL	KEY_BS		,key_toggle_buffering_mode
		KEYTBL	KEY_CLR		,key_clear_buffer
		KEYTBL_END
shift_key_table:
		KEYTBL	KEY_^		,key_search_backward
		KEYTBL	KEY_F3		,key_search_backward
		KEYTBL	KEY_F4		,key_search_backward_next
		KEYTBL	KEY_N		,key_search_backward_next
		KEYTBL	KEY_D		,key_toggle_past_header_bracket
		KEYTBL	KEY_7		,key_jump_label
		KEYTBL_END

		.endif

* y[Xgwb_ύX
key_toggle_past_header_tab:
		moveq	#TAB,d0
		bra	@f
key_toggle_past_header_hyphen:
		moveq	#'-',d0
		bra	@f
key_toggle_past_header_colon:
		moveq	#':',d0
		bra	@f
key_toggle_past_header_bracket:
		move.b	(default_past_header,pc),d0
@@
		lea	(past_header,pc),a0
		cmp.b	(a0),d0
		bne	@f
		moveq	#0,d0			ɐݒ肳Ă
@@
		move.b	d0,(a0)
		bra	display_system_status

* }[N ---------------------------------------

		.ifndef	__EMACS
key_mark_change_led:
		bchg	#LED_INS_bit,(LEDSTAT)	* INS  LED Ԃ𔽓]
		IOCS	_LEDSET
key_mark_dont_change_led:
		move.l	(mark_char_adr,pc),d0
		beq	key_set_mark
clear_mark_and_redraw:
		bsr	clear_mark
		bra	draw_backscroll
		.endif

clear_mark:
		lea	(mark_char_adr,pc),a0
		clr.l	(a0)+
		clr.l	(a0)
		.ifdef	__EMACS
			rts
		.else
			bclr	#LED_INS_bit,(LEDSTAT)
			bra	call_iocs_ledset
		.endif

key_set_mark:
		.ifdef	__EMACS
			lea	(set_mark_mes,pc),a1
			bsr	print_message
		.endif
key_set_mark_quiet:
		bsr	get_cursor_line_buffer
		bpl	@f

		movea.l	(buffer_now,a6),a1	;obt@Ȃ_~[ݒ肷
@@:
		lea	(mark_line_adr,pc),a0
		move.l	a1,(a0)
		adda	(cursorXbyte,pc),a1
		addq.l	#1,a1
		EndChk2	a1
		move.l	a1,-(a0)		;mark_char_adr

		.ifndef	__EMACS
		bra	draw_backscroll

		.else
exg_point_mark_end:
		rts

key_exchange_point_and_mark:
		move.l	(mark_char_adr,pc),d2
		beq	exg_point_mark_end
		move.l	(mark_line_adr,pc),d1
		bsr	key_set_mark_quiet

		movea.l	d2,a1
		sub.l	d1,d2
		subq	#1,d2
		bra	jump_scroll_2
		.endif

* obNXN[ʊgEk -------------- *

* ~DOWN : obNOʂɍLĈs₷
key_grow_window:
		move.b	(bitflag,pc),d0		HELPMODE_bit
		bmi	grow_window_end

		lea	(down_line,pc),a4
		move	(a4)+,d0		Ɉړs
		add	(window_line-(down_line+2),a4),d0
		cmpi	#28,d0
		bcc	grow_window_end

		lsl	#2,d0			d0*4+(12-1) -> d0*4+(16-1)
		move.b	d0,-(sp)	*	move.b	d0,d1
		move	(sp)+,d1	*	lsl	#8,d1
		move.b	d0,d1
		addi	#(12-1).shl.8+(16-1),d1
		moveq	#(2+4),d0
		bsr	rascpy_down

		addq	#1,(a4)			;window_line
		bsr	reset_line_address_buf
		lea	(line_buf,pc),a3

		move	(a4),d0
		bsr	draw_line_d0
		lsl	#2,d0
		tst.l	(a3,d0.w)
		bmi	key_move_window_up
grow_window_end:
shrink_window_end:
		rts

* ~UP : obNOʂɋ߂Ĉs炷
key_shrink_window:
		move.b	(bitflag,pc),d0		;HELPMODE_bit
		bmi	shrink_window_end

		lea	(window_line,pc),a4
		move	(a4),d0
		cmpi	#4,d0
		bcs	shrink_window_end

		lea	(cursorY,pc),a1
		cmp	(a1),d0
		bne	shrink_window_cursor_fixed

		lea	(line_buf,pc),a0	;J[\ŉsɂꍇ
		lea	(4,a0),a2		;XN[Abv
		subq	#1,d0
@@:
		move.l	(a2)+,(a0)+
		dbra	d0,@b
		subq	#1,(a1)			cursorY
		bsr	rascpy_up_all
shrink_window_cursor_fixed:
		lea	(line_buf,pc),a3	;bZ[W\sɈړ
		move	(a4),d0
		subq	#1,(a4)			;window_line
		lsl	#2,d0
		st	(a3,d0.w)
		move	d0,d1
		addq	#4,d1
		lsl	#8,d1
		move.b	d0,d1
		moveq	#2+4,d0
		bsr	rascpy_up

		bra	clear_text_raster_mesline

* obNXN[EBhËړ ------------ *

* ~ROLLDOWN : obNOʂɈړ
key_slide_window_up:
		lea	(down_line,pc),a4
		move	(a4)+,d1
		beq	slide_window_up_end	;ȏړłȂ

		move	#$fdfa,d1		;@-2 -> @-2-4
		move	(a4),d0			;window_line
		addq	#2+1,d0
		bsr	rascpy_up_shl2

		lea	(text_address,pc),a0
		subi.l	#$800,(a0)+
		subi	#$404,(a0)+
		subq	#1,(a0)+

		bra	clear_text_raster_mesline	;ȑO̍ŉs

* ~ROLLUP : obNOʂɈړ
key_slide_window_down:
		move	(down_line,pc),d3
		move	(window_line,pc),d0
		add	d3,d0
		cmpi	#28,d0
		bcc	slide_window_down_end	;ȏړłȂ

		addq	#3,d0
		lsl	#2,d0
		subq	#1,d0
		move.b	d0,-(sp)
		move	(sp)+,d1
		addq	#4,d0
		move.b	d0,d1
		move	(window_line,pc),d0
		addq	#3,d0
		lsl	#2,d0			;(s+2)*4
		bsr	rascpy_down

		moveq	#0,d1
		move.b	(text_ras_no,pc),d1
		subq	#2,d1
		bsr	clear_text_raster_m4	;ȑO̐擪s

		lea	(text_address,pc),a0
		addi.l	#$800,(a0)+
		addi	#$404,(a0)+
		addq	#1,(a0)+
slide_window_up_end:
slide_window_down_end:
write_cancel:
		rts

* --------------------------------------------- *

* ^@ : t@Co
key_write_file:
		lea	(write_file_prompt,pc),a1
		bsr	input_string
		beq	write_cancel
		bsr	check_diskready
		bmi	disk_notready_error

		move	#ARCHIVE,-(sp)
		move.l	a1,-(sp)
		DOS	_NEWFILE
		addq.l	#6,sp
		move.l	d0,d4
		bpl	write_file_status_check

		move	#WOPEN,-(sp)
		move.l	a1,-(sp)
		DOS	_OPEN
		addq.l	#6,sp
		move.l	d0,d4
		bmi	fileopen_error

		move	#2,-(sp)		݃I[vꍇ͖ɃAyh
		clr.l	-(sp)
		move	d4,-(sp)
		DOS	_SEEK
		addq.l	#8,sp
write_file_status_check:
		moveq	#7,d1
		bsr	is_file_io_enable
		bne	filewrite_disable

		move.l	(mark_char_adr,pc),d0
		bne	write_file_mark_area

		moveq	#0,d0
		moveq	#0,d2
		movea.l	(buffer_old,a6),a0	;}[NȂ͍̎ŏŌ܂
		addq.l	#1,a0
		EndChk	a0
		move.b	(a0)+,d2
		EndChk	a0
		movea.l	(buffer_now,a6),a1
		tst.b	(a1)+
		beq	@f

		movea.l	(buffer_write,a6),a1
		addq.l	#2,a1			słȂꍇ͋[IȎ̍sz肷
@@
		bra	write_file_loop_1

write_file_mark_area:
		bsr	get_mark_area
		beq	write_cancel
* d0	ɓ]錅ʒu
* d1	obt@݃oCg
* d2	ݍš
* a0	obt@ړ_
* a1	IAhX
write_file_loop_1:
		lea	(io_buffer,pc),a2
		moveq	#0,d1
write_file_loop_2:
		cmp	d0,d2
		bne	@f
		addq.l	#1,a0			;̍s
		EndChk	a0
		moveq	#0,d0
		moveq	#0,d2
		move.b	(a0)+,d2
		EndChk	a0
@@:
		cmpa.l	a0,a1
		beq	write_file_end
		move.b	(a0)+,d3
		EndChk	a0
		cmpi.b	#CR,d3
		bne	@f
		moveq	#LF,d3
@@
		move.b	d3,(a2)+
		addq	#1,d0
		addq	#1,d1
		cmpi	#IOBUFSIZE,d1
		bne	write_file_loop_2
		bsr	write_file_sub
		bra	write_file_loop_1

write_file_end:
		tst	d1
		beq	@f
		bsr	write_file_sub
@@
		.ifndef	__EMACS
			bsr	clear_mark_and_redraw
		.endif
		bsr	close_filehandle_d4

write_file_sub:
		move.l	d0,-(sp)
		move.l	d1,-(sp)
		pea	(io_buffer,pc)
		move	d4,-(sp)
		DOS	_WRITE
		lea	(10,sp),sp
		move.l	(sp)+,d0
		rts

*  ------------------------------------ *

		.ifdef	__EMACS

wait_vdisp_vsync:
		btst	#4,(MFP_GPIP)
		beq	wait_vdisp_vsync
wait_vsync:
		btst	#4,(MFP_GPIP)
		bne	wait_vsync
		rts

visual_bell:
		lea	(2*(4+4)+TEXTPAL),a1
		move.l	-(a1),-(sp)		* wiFҔ
		move.l	-(a1),-(sp)
		move	(2*(12-4),a1),d1	* F

		bsr	wait_vsync
		bsr	set_text_pallet
		subq.l	#4*2,a1

		bsr	wait_vdisp_vsync

		move.l	(sp)+,(a1)+		* wiFA
		move.l	(sp)+,(a1)+
		rts

call_dos_keyctrl_md0:
		moveq	#0,d0
call_dos_keyctrl:
		move	d0,-(sp)		* 0/1
		DOS	_KEYCTRL
		move	d0,(sp)+
		rts

* d7.w
*	bit 15 = 0:forward
*		 1:backward
*	bit  7 = 0:L̓[h(C-q/C-v̒)
*		 1:ʏ탂[h
*	bit 6`0:\

ISCH_DIRECT:	.equ	15
ISCH_INPUT:	.equ	7

* O
key_isearch_forward:
		moveq	#0,d7
		bra	@f
* 
key_isearch_backward:
		moveq	#1,d7			;move	#1<<ISCH_DIRECT,d7
		ror	#1,d7
@@:
		move	(cursorY,pc),-(sp)
		move.l	(cursorX,pc),-(sp)	cursorX/Xbyte
		move.l	(line_buf,pc),-(sp)
usestack:	.equ	2+4+4

* Ē`\ȃL[̓eύX
		pea	(fnckey_buf,pc)
		clr	-(sp)			
		DOS	_FNCKEY
		addq.l	#6,sp

		lea	(ise_fnc_tbl,pc),a0
		bra	isearch_setfnc
isearch_setfnc_loop:
		move.l	a0,-(sp)
		move	d0,-(sp)
		DOS	_FNCKEY
		addq.l	#6,sp
@@
		tst.b	(a0)+
		bne	@b
isearch_setfnc:
		move	#$01_00,d0		ݒ
		move.b	(a0)+,d0
		bne	isearch_setfnc_loop

		bsr	gm_inactive
		bsr	fep_enable

* general_work:	.dc.b	'isearch ['
*		.dc.b	O񌟍
*		.dc.b	']:'
*		.dc.b			(a5)

		lea	(str_copy,pc),a3
		lea	(general_work,pc),a4
		lea	(a4),a1
		lea	(iearch_mes_1,pc),a0
		jsr	(a3)
		lea	(isearch_string_buf,pc),a0
		jsr	(a3)
		lea	(iearch_mes_2,pc),a0
		jsr	(a3)
		lea	(a1),a5			obt@̃AhX

		tas	d7
isearch_redraw_loop:
		lea	(a4),a1
		bsr	print_message
isearch_loop:
		bsr	blink_cursor
		moveq	#1,d0
		bsr	call_dos_keyctrl
		beq	isearch_loop
		bsr	call_dos_keyctrl_md0
		beq	isearch_loop		Ö

		bsr	clear_cursor
*** Ľ ***
		move.b	d0,d1
		addq.b	#1,d1
		beq	isearch_fnckey		J[\ꍇ(C-qɌ)

		tas	d7
		bpl	isearch_next_char	C-q,C-v̒

		lea	(isearch_table,pc),a0
@@
		move	(a0)+,d1
		beq	@f
		cmp	(a0)+,d0
		bne	@b
		adda	d1,a0
		jmp	(a0)
@@
		cmpi	#$20,d0			oChĂȂL͂ꂽ
		bmi	isearch_exit		͐甲ĕ]
isearch_next_char:
		bsr	get_isearch_strlen

		lea	(ctype_table,pc),a2
		tst.b	(a2,d0.w)		MULTIBYTE
		bmi	isearch_mb
* isearch_single_byte_code:
		tst.b	d0
		bmi	isearch_sb		pЉ
		KEYbtst	KEY_XF3
		beq	isearch_sb
		cmpi.b	#$40,d0
		bmi	@f
		andi.b	#$1f,d0
@@
		bra	isearch_exit		Meta+??
isearch_mb:
		lsl	#8,d0
		move	d0,-(sp)
		bsr	call_dos_keyctrl_md0	2byteڂ菜
		or	(sp)+,d0		High/Low
isearch_mb_2:
		cmpi	#GETSMAX-1,d1
		bcc	isearch_bell

		move	d0,-(sp)		ʃoCg
		move.b	(sp)+,(a0)+
		tst.b	d0
		bne	isearch_sb_2

		clr.b	-(a0)			$??_00͖
		bra	isearch_loop
isearch_sb:
		cmpi	#GETSMAX,d1
		bcc	isearch_bell
isearch_sb_2:
		move.b	d0,(a0)+		ʃoCg
		clr.b	(a0)

		bsr	print_message_cont
		st	(isearch_flag-general_work,a4)
isearch_search_next:
		lea	(a5),a1
		tst.b	(a5)
		bne	@f
		lea	(isearch_string_buf,pc),a1
@@:
		PUSH	d7/a4/a5
		move	d7,-(sp)
		bsr	make_search_work_a1
		beq	isearch_search_skip

		tst	(sp)
		bmi	isearch_search_backward

		bsr	search_forward_main
		bra	isearch_search_skip
isearch_search_backward:
		bsr	search_backward_main
isearch_search_skip:
		addq.l	#2,sp
		POP	d7/a4/a5
		bpl	@f			;񂪋or
isearch_bell:
		bsr	visual_bell
@@:
		bra	isearch_loop

;CӐݒ肪\ȃL[̏
isearch_fnckey:
		bsr	call_dos_keyctrl_md0
		beq	isearch_loop
		cmpi	#11,d0
		bhi	isearch_loop
		add	d0,d0

		move.b	(SFTSTAT),d1
		KEYbtst	KEY_XF3
		beq	@f

		lea	(key_slide_window_down,pc),a0
		subq	#4,d0			;2/4̂bindĂ
		bhi	isearch_loop
		bmi	isearch_fnckey_jump
		lea	(key_slide_window_up,pc),a0
		bra	isearch_fnckey_jump
@@:
		lea	(isearch_fnckey_normal,pc),a0
		bclr	#SFT_CTRL_bit,d1
		beq	@f
		lea	(isearch_fnckey_ctrl,pc),a0
@@:
		move	(-2,a0,d0.w),d0
		beq	isearch_loop
		adda	d0,a0
isearch_fnckey_jump:
		tst.b	d1
		bne	isearch_loop
isearch_fnckey_exit:
		addq.l	#usestack-4,sp		*lea	(usestack,sp),sp
		move.l	a0,(sp)			*move.l a0,-(sp)

		bra	isearch_end

isearch_fnckey_normal:
@@:		.dc	key_scroll_up-@b	ROLL UP
		.dc	key_scroll_down-@b	ROLL DOWN
		.dc	key_kill_region-@b	DEL
		.dc	key_previous_line-@b	
		.dc	key_backward_char-@b	
		.dc	key_forward_char-@b	
		.dc	key_next_line-@b	
		.dc	0			CLR
		.dc	key_help-@b		HELP
		.dc	key_kill_condrv-@b	HOME
		.dc	key_kill_condrv-@b	UNDO

isearch_fnckey_ctrl:
@@:		.dc	key_end_of_buffer_mark-@b	ROLL UP
		.dc	key_beginning_of_buffer_mark-@b	ROLL DOWN
		.dc	0			DEL
		.dc	key_shrink_window-@b	
		.dc	key_move_window_up-@b	
		.dc	key_move_window_down-@b	
		.dc	key_grow_window-@b	
		.dc	key_clear_buffer-@b	CLR
		.dc	0			HELP
		.dc	0			HOME
		.dc	key_suspend_condrv-@b	UNDO

ISETBL:		.macro	address,char
		.dc	address-($+4),CTRL+char
		.endm

isearch_table:
		ISETBL	isearch_next_char	,'I'	* TAB
		ISETBL	isearch_next_char	,'M'	* CR
		ISETBL	isearch_lf		,'J'	* LF(-> CR)

		ISETBL	isearch_meta_end	,'['	* ESC
		ISETBL	isearch_ctrl_g_end	,'G'
		ISETBL	isearch_ctrl_s		,'S'
		ISETBL	isearch_ctrl_r		,'R'
		ISETBL	isearch_backspace_b	,'B'
		ISETBL	isearch_backspace_h	,'H'
		ISETBL	isearch_ctrl_f		,'F'
		ISETBL	isearch_input_ctrlcode	,'V'
		ISETBL	isearch_input_ctrlcode	,'Q'
		.dc	0

isearch_lf:
		moveq	#CR,d0			sƌȂ
		bra	isearch_next_char

isearch_ctrl_s:
		bclr	#ISCH_DIRECT,d7
		bra	@f
isearch_ctrl_r:
		bset	#ISCH_DIRECT,d7
@@:
		bra	isearch_search_next

isearch_input_ctrlcode:
		clr.b	d7
		bra	isearch_loop

isearch_backspace_h:
		SFTbtst	SFT_CTRL_bit
		beq	@f
		KEYbtst	KEY_H
		bne	@f
		KEYbtst	KEY_BS
		lea	(key_toggle_buffering_mode,pc),a0
		bne	isearch_fnckey_exit	;C-bs
@@:
isearch_backspace_b:
		lea	(a5),a0
		moveq	#0,d0
		move.b	(a0)+,d0
		beq	isearch_loop		͋

		lea	(ctype_table,pc),a1
@@
		tst.b	(a1,d0.w)		MULTIBYTE
		smi	d1
		ext	d1			p=$0000,Sp=$ffff
		suba	d1,a0			SpȂ1bytei߂
		move.b	(a0)+,d0
		bne	@b

		clr.b	(-2,a0,d1.w)		Ō̕
		bsr	clear_message
		bra	isearch_redraw_loop

isearch_ctrl_f:
		lea	(line_buf,pc),a1
		movem	(cursorX,pc),d2/d3/d4
		lsl	#2,d4			cursorY
		movea.l	(a1,d4.w),a1
		moveq	#0,d1
		move.b	(a1)+,d1		ڍs̕
		adda	d3,a1			cursorXbyte

		lea	(a5),a0
pickup_char_loop:
		bsr	get_char
		moveq	#0,d4
		move.b	(a0)+,d4
		beq	pickup_cursor_char
		tst	d0
		bmi	pickup_char_cmp_mb

		lea	(case_table,pc),a2
		move.b	(a2,d4.w),d4		-x IvVɂĂ͑啶
		cmp.b	(a2,d0.w),d4		ꎋĔr
		bne	isearch_bell
		bra	@f
pickup_char_cmp_mb:
		lsl	#8,d4			2bytes
		move.b	(a0)+,d4
		cmp	d0,d4
		bne	isearch_bell
@@
		cmp	d1,d2
		bne	pickup_char_loop

		addq.l	#1,a1
		move.b	(a1)+,d1		s̃oCg
		moveq	#0,d2			cursorX
		moveq	#0,d3			cursorXbyte
		bra	pickup_char_loop

pickup_cursor_char:
		bsr	get_isearch_strlen
		tst	d0
		bmi	isearch_mb_2
		bne	isearch_sb
*		beq	isearch_ctrl_f_end	Ȃ
isearch_ctrl_f_end:
		bra	isearch_loop

get_isearch_strlen:
		lea	(a5),a0
@@
		tst.b	(a0)+
		bne	@b
		subq.l	#1,a0
		move.l	a0,d1
		sub.l	a5,d1			d1=
		lea	(a0),a1			print_message_contp
		rts

isearch_ctrl_g_end:
		movea.l	(sp)+,a0		;line_buf
		bsr	reset_line_address_buf_2

		lea	(cursorX,pc),a0
		move.l	(sp)+,(a0)+		cursorX/Xbyte
		move	(sp)+,(a0)		cursorY
		bsr	draw_backscroll
		bra	isearch_end

isearch_exit:
		lea	(ctrl2scan_table,pc),a0
		addq.l	#usestack-2,sp		*lea	(usestack,sp),sp
		move.b	(a0,d0.w),(sp)		*move.b	(a0,d0.w),-(sp)
		pea	(keyinp_direct,pc)
		bra	isearch_end

isearch_meta_end:
		lea	(usestack,sp),sp
		bra	isearch_end

isearch_end:
		tst.b	(a5)			ۑ
		beq	1f
		lea	(isearch_string_buf,pc),a0
@@		move.b	(a5)+,(a0)+
		bne	@b
1:
* Ē`\ȃL[̓e߂
		pea	(fnckey_buf,pc)
		move	#$01_00,-(sp)		ݒ
		DOS	_FNCKEY
		addq.l	#6,sp

		bsr	clear_cursor
		bsr	fep_disable
		bra	gm_active

		.endif

*  -----------------------------------------

* C-^
key_search_forward_current_word:
		bsr	readline_yank_current_word
		bra	key_search_forward
* ^
key_search_forward:
		lea	(search_forward_mes,pc),a1
		bsr	input_string
		beq	search_forward_end
		bsr	copy_search_str
key_search_forward_next:
		bsr	make_search_work
		beq	search_forward_end
		lea	(searching_mes,pc),a1
		bsr	print_message
		bsr	search_forward_main
search_found_or_not:
		lea	(not_found_mes,pc),a1
		bmi	print_message
		bra	clear_message

readline_yank_current_word:
		moveq	#GETSMAX,d2
		lea	(RL_PASTBUF,pc),a2
		bsr	yank_current_word_sub
		lea	(RL_PASTBUF,pc),a0
		move.l	a0,(past_pointer-RL_PASTBUF,a0)
search_forward_end:
		rts

* ėpobt@猟pobt@ɑҔĂ
copy_search_str:
		lea	(search_string_buf,pc),a0
@@		move.b	(a1)+,(a0)+
		bne	@b
		rts

* in	a1.l	
* out	d7.w	ŏ̂P(.hb=0)
*	a0.l	case_table
*	a3.l	line_buf
*	a4.l	search_sub()
*	a5.l	     (a5):
*		  (70,a5):e[u
KANJITBL	.equ	GETSMAX+1
make_search_work:
		lea	(search_string_buf,pc),a1
make_search_work_a1:
		lea	(case_table,pc),a0
		lea	(line_buf,pc),a3
		lea	(search_sub,pc),a4
		moveq	#0,d0
		moveq	#0,d7
		lea	(search_string,pc),a5
		lea	(a5),a2

		move.b	(a1)+,d7		ŏ̂P
		beq	make_search_work_end
		move.b	(a0,d7.w),d7		炩ߑ啶Ă
		tst.b	(KANJITBL,a5,d7.w)
		bmi	make_search_str_mb_low

@@		move.b	(a1)+,d0
		tst.b	(KANJITBL,a5,d0.w)
		bmi	make_search_str_mb_high
		move.b	(a0,d0.w),(a2)+
make_search_str_next:
		bne	@b
@@		moveq	#1,d0
make_search_work_end:
		rts

make_search_str_mb_high:
		move.b	d0,(a2)+
		beq	@b
make_search_str_mb_low:
		move.b	(a1)+,(a2)+		ʃoCg(啶Ȃ)
		bra	make_search_str_next

search_forward_main:
		bsr	search_sub_getcur
		bmi	search_not_found

		bsr	check_isearch_flag
		beq	@f

		subq.l	#1,a1
		subq	#1,d2
@@:
search_forward_skip_lowbyte:
		moveq	#0,d3
search_forward_not_match:
		addq.l	#1,a1			;̕璲ׂ
		EndChk	a1
		addq	#1,d2
		cmp	d1,d2			;
		bne	search_forward_char

		tst.b	(a1)+
		beq	search_not_found	;obt@܂ŌȂ
		EndChk	a1
		moveq	#0,d2
		moveq	#0,d1
		move.b	(a1)+,d1		;
		beq	search_not_found
		EndChk	a1
search_forward_char:
		tst.b	(KANJITBL,a5,d3.w)	r̂SpȂ牺ʃoCg΂
		bmi	search_forward_skip_lowbyte

		move.b	(a1),d3
		cmp.b	(a0,d3.w),d7
		bne	search_forward_not_match
		jsr	(a4)			search_sub
		bne	search_forward_not_match	ڈʒu͈vȂ
jump_scroll_2:
		bsr	search_zenkaku_check	Xbyte̎̂
search_found_scroll:
		subq.l	#1,a1
		suba	d2,a1
		TopChk	a1
jump_scroll:
		lea	(line_buf,pc),a3
		movea.l	(a3),a0
		move	(window_line,pc),d0
@@
		tst.l	(a3)
		bmi	@f
		cmpa.l	(a3)+,a1
		beq	jump_scroll_same_page	sݕ\ȂXN[Ȃ
		dbra	d0,@b
@@
		movea.l	a1,a0			sŏiɕ\
jump_scroll_same_page:
		PUSH	d2/a1
		bsr	reset_line_address_buf_2
		tst	d1
		bmi	@f			\sf[^(ł͂Ȃ)
		bsr	end_of_buffer_sub
@@
		POP	d2/a1
		moveq	#-1,d1
		lea	(line_buf,pc),a3
@@
		addq	#1,d1
		cmpa.l	(a3)+,a1		s̕\͉sڂH(XN[ꍇ 0)
		bne	@b

		lea	(cursorX,pc),a0
		move	d3,(a0)+		cursorX
		move	d2,(a0)+		cursorXbyte
		move	d1,(a0)			cursorY
		bsr	draw_backscroll
		moveq	#0,d0
search_backward_end:
		rts

search_sub_getcur:
		bsr	get_cursor_line_buffer
		bmi	@f

		moveq	#0,d1
		move.b	(a1)+,d1		;
		EndChk	a1
		move	(cursorXbyte,pc),d2
		adda	d2,a1
		EndChk2	a1

		tst	d2			;not minus
@@:		rts

check_isearch_flag:
		lea	(isearch_flag,pc),a2
		tst.b	(a2)
		sf	(a2)
		rts

* C-\
key_search_backward_current_word:
		bsr	readline_yank_current_word
		bra	key_search_backward
* ^
key_search_backward:
		lea	(search_backward_mes,pc),a1
		bsr	input_string
		beq	search_backward_end
		bsr	copy_search_str
key_search_backward_next:
		bsr	make_search_work
		beq	search_backward_end
		lea	(searching_mes,pc),a1
		bsr	print_message
		bsr	search_backward_main
		bra	search_found_or_not

search_backward_main:
		bsr	search_sub_getcur
		bmi	search_not_found

		bsr	check_isearch_flag
		beq	@f

		addq.l	#1,a1
		addq.b	#1,d2
@@:
		moveq	#0,d3
search_backward_not_match:
		subq.l	#1,a1
		TopChk	a1
		subq.b	#1,d2
		bpl	search_backward_cmp
		subq.l	#1,a1			s̐擪܂őkꍇ
		TopChk	a1
		moveq	#0,d1
		move.b	(a1),d2			O̍s̉E[
		bne	search_backward_not_match
search_not_found:
		moveq	#-1,d0
		rts
search_backward_cmp:
		move.b	(a1),d3
		cmp.b	(a0,d3.w),d7
		bne	search_backward_not_match
		jsr	(a4)			search_sub
		bne	search_backward_not_match

		bsr	search_zenkaku_check	v񂪑Sp̓r炩ׂ
		bcs	search_backward_not_match
		bra	search_found_scroll

search_zenkaku_check:
usereg		.reg	d1-d2/a1
		PUSH	usereg
		suba	d2,a1
		TopChk	a1
		move	d2,d1
		moveq	#0,d2
		moveq	#0,d3
		bra	@f
zenkaku_check_loop:
		bsr	get_char
@@		cmp	d2,d1
		bhi	zenkaku_check_loop
		POP	usereg
		rts

* Tu(2ڈȍ~r)
search_sub:
usereg		.reg	d1-d4/a1-a2/a5
		PUSH	usereg
		lea	(a5),a2
		moveq	#0,d0
search_sub_loop:
		move	d3,d4			O̔r
		move.b	(a5)+,d3
		beq	search_sub_found
		addq.l	#1,a1
		EndChk	a1
		addq	#1,d2
		cmp	d1,d2
		bne	search_sub_cmpchar

		tst.b	(a1)+
		beq	search_sub_not_found
		EndChk	a1
		moveq	#0,d2
		moveq	#0,d1
		move.b	(a1)+,d1
		beq	search_sub_not_found
		EndChk	a1
search_sub_cmpchar:
		move.b	(a1),d0
		tst.b	(KANJITBL,a2,d4.w)
		bmi	@f
		move.b	(a0,d0.w),d0
@@		cmp.b	d0,d3
		beq	search_sub_loop
search_sub_not_found:
		moveq	#-1,d0
search_sub_found:
		POP	usereg
		rts

* I -----------------------------------------

* OPT.1 + UNDO : ʂc܂܏I
key_suspend_condrv:
		lea	(bitflag,pc),a0
		tst.b	(a0)			HELPMODE_bit
		bmi	key_kill_condrv		wv[hȂ甲邾
		bset	#SUSPEND_bit,(a0)
key_kill_condrv:
		addq.l	#4,sp
		rts

* J[\s̃obt@AhX߂ -------- *
* out	a1.l	AhX
*	a3.l	line_buf
*	ccr N	0:OK 1:error

get_cursor_line_buffer:
		movea.l	d0,a1
		lea	(line_buf,pc),a3
		move	(cursorY,pc),d0
		lsl	#2,d0
		move.l	(a3,d0.w),d0
		exg	d0,a1
		rts

* Jbgy[Xg ---------------------------- *

		.ifdef	__EMACS			;+07b
key_yank_region:
		move.l	(mark_char_adr,pc),d0
		bne	@f

		bsr	visual_bell		;}[NȂȂG[
		lea	(no_mark_err_mes,pc),a1
		bra	print_message
@@:
		.else
key_yank:
		move.l	(mark_char_adr,pc),d0	;}[NĂȂ
		beq	key_yank_current_word	;J[\ʒu̒Py[Xg
		.endif

		bsr	get_mark_area
		beq	yank_nothing

		bsr	kill_region_start
yank_and_kill_condrv:
		addq.l	#4,sp
yank_sub:
		lea	(bitflag,pc),a0
		bset	#AFTERCR_bit,(a0)	stO𗧂Ăăy[Xgʒu擪ɂ
		move.l	(pastbuf_adr,pc),(past_pointer-bitflag,a0)
		rts
yank_nothing:
		addq.l	#4,sp
		rts

key_yank_current_word:
		movem.l	(pastbuf_size,pc),d2/a2
*		movea.l	(pastbuf_adr,pc),a2
		bsr	yank_current_word_sub
		bra	yank_and_kill_condrv

yank_current_word_sub:
		lea	(line_buf,pc),a3
		move	(cursorY,pc),d0
		lsl	#2,d0
		movea.l	(a3,d0.w),a1
		moveq	#0,d3
		move.b	(a1)+,d3
		move	(cursorXbyte,pc),d1
		adda	d1,a1
		EndChk2	a1
		bra	@f
yank_current_word_loop:
		cmp	d1,d3
		beq	yank_current_word_endofline
yank_current_word_nextline:
		move.b	(a1)+,d0
		cmpi.b	#$20,d0
		bls	yank_current_word_end
		EndChk	a1
		move.b	d0,(a2)+
		addq	#1,d1
@@:
		subq.l	#1,d2
		bne	yank_current_word_loop
yank_current_word_end:
		bra	set_nulstr_yankptr

yank_current_word_endofline:
		tst.b	(a1)+
		beq	yank_current_word_end
		EndChk	a1
		move.b	(a1)+,d3
		beq	yank_current_word_end
		EndChk	a1
		moveq	#0,d1
		bra	yank_current_word_nextline

* [W̃AhX𓾂 ------------------ *
* out	d0.w/d1.w	O[E[̌ʒu(oCgP)
*	d2.w/d3.w	V	    soCg
*	a0.l/a1.l	V	    AhX
* ccrZ	0:OK 1:͈͂

get_mark_area:
		move.l	(mark_char_adr,pc),d1
		beq	get_mark_area_end

		movea.l	(mark_line_adr,pc),a0
		moveq	#0,d0
		moveq	#0,d2
		move.b	(a0)+,d2		d2.w=}[Nš
		bra	@f
1:
		addq	#1,d0			d0.w=markXbyte
		addq.l	#1,a0			a0.l=}[Nʒu
@@:
		EndChk	a0
		cmpa.l	d1,a0
		bne	1b

		bsr	get_cursor_line_buffer
		bpl	@f

		moveq	#0,d0
		bra	get_mark_area_end
@@:
		moveq	#0,d3
		move.b	(a1)+,d3		d3.w=J[\ʒǔ

		move	(cursorXbyte,pc),d1
		adda	d1,a1			a1.l=J[\ʒu
		EndChk2	a1
		cmpa.l	a0,a1
		bcc	@f
		exg	d0,d1			a0.l:Jn<a1.l:Iɂ
		exg	d2,d3
		exg	a0,a1
@@:
		cmpa.l	(buffer_old,a6),a0
		bcc	@f
		cmpa.l	(buffer_old,a6),a1
		bcs	@f
		exg	d0,d1			a1.l<=old<a0.lȂ
		exg	d2,d3
		exg	a0,a1
@@:
		cmpa.l	a0,a1			;equalȂcursor==mark
get_mark_area_end:
kill_region_end:
		rts

key_kill_region:
		addq.l	#4,sp
key_copy_region:
		bsr	get_mark_area
		beq	kill_region_end		;}[N͈͖͂
kill_region_start:
		movem.l	(pastbuf_size,pc),d1/a2
*		movea.l	(pastbuf_adr,pc),a2
		subq.l	#1,d1
kill_region_loop:
		cmp	d0,d2
		bne	@f
		moveq	#0,d0			̍s
		addq.l	#1,a0
		EndChk	a0
		move.b	(a0)+,d2
		EndChk	a0
@@:
		cmpa.l	a0,a1
		beq	@f
		move.b	(a0)+,(a2)+
		EndChk	a0
		addq	#1,d0
		subq.l	#1,d1
		bne	kill_region_loop
@@
		bra	set_nulstr_yankptr

*  U : J[\`y[Xg
key_yank_from_beginning_of_line:
		bsr	kill_from_beginning_of_line_sub
		bra	yank_and_kill_condrv
* ^U : J[\`Jbg
key_kill_from_beginning_of_line:
		addq.l	#4,sp
		bra	kill_from_beginning_of_line_sub

kill_from_beginning_of_line_sub:
		lea	(line_buf,pc),a3
		move	(cursorY,pc),d0
		lsl	#2,d0
		movea.l	(a3,d0.w),a1
		movea.l	a1,a0			s

		adda	(cursorXbyte,pc),a1
		addq.l	#1,a1			|C^
		EndChk2	a1
		moveq	#0,d2
		bra	1f
@@:
		suba	d2,a0
1:
		subq.l	#1,a0
		TopChk	a0
		move.b	(a0),d2			O̍s̃oCg
		subq.l	#1,a0
		beq	@f
		TopChk	a0
		cmpi.b	#CR,(a0)
		bne	@b			O̍ssŏI܂ŌJԂ
@@
		addq.l	#2,a0
		EndChk2	a0
		move.b	(a0)+,d2
		EndChk	a0
		moveq	#0,d0
		bra	kill_region_start

*  K : J[\`y[Xg
key_yank_to_end_of_line:
		bsr	kill_to_end_of_line_sub
		bra	yank_and_kill_condrv
* ^K : J[\`Jbg
key_kill_to_end_of_line:
		addq.l	#4,sp
		bra	kill_to_end_of_line_sub

kill_to_end_of_line_sub:
		lea	(line_buf,pc),a3
		move	(cursorY,pc),d0
		lsl	#2,d0
		movea.l	(a3,d0.w),a1
		moveq	#0,d3
		move.b	(a1)+,d3

		move	(cursorXbyte,pc),d1
		adda	d1,a1
		EndChk2	a1
		movem.l	(pastbuf_size,pc),d2/a2
*		movea.l	(pastbuf_adr,pc),a2
		subq.l	#1,d2
kill_to_end_of_line_loop:
		cmp	d1,d3
		bne	@f

		tst.b	(a1)+			J[\E[ɂꍇ
		beq	set_nulstr_yankptr
		EndChk	a1
		move.b	(a1)+,d3
		beq	set_nulstr_yankptr
		EndChk	a1
		moveq	#0,d1
@@
		move.b	(a1)+,d0
		cmpi.b	#CR,d0
		beq	set_nulstr_yankptr
		EndChk	a1
		move.b	d0,(a2)+
		addq	#1,d1
		subq.l	#1,d2
		bne	kill_to_end_of_line_loop
set_nulstr_yankptr:
		clr.b	(a2)
		lea	(past_pointer,pc),a1
		move.l	a2,(a1)
		rts

* Jbgy[Xg / J[\ړ ----------

* A : ꍶɈړ
@@:
		move	(cursorY,pc),d0
		lsl	#2,d0
		movea.l	(a3,d0.w),a1
		subq.l	#2,a1
		TopChk	a1
		cmpi.b	#CR,(a1)
		beq	backward_word_end
key_backward_word:
		bsr	key_backward_char
		tst.l	d0
		bmi	backward_word_end
		beq	@f
		cmpi	#CR,d0
@@:		beq	backward_word_end

		move	(cursorXbyte,pc),d1
		beq	@b			[܂Ői
		cmpi	#$20,d0
		bls	key_backward_word
		move	(cursorY,pc),d0
		lsl	#2,d0
		movea.l	(a3,d0.w),a1
		adda	d1,a1
		EndChk2	a1
		cmpi.b	#$20,(a1)
		bhi	key_backward_word
backward_word_end:
forward_word_end:
		rts

* F : EɈړ
key_forward_word:
		bsr	get_cursor_line_buffer
		bmi	forward_word_end

		move	(cursorXbyte,pc),d1
		adda	d1,a1
		addq.l	#1,a1
		EndChk2	a1
		cmpi.b	#CR,(a1)
		beq	key_forward_char
forward_word_loop:
		cmpi.b	#SPACE,(a1)
		sls	d4
		bsr	key_forward_char

		move	(cursorY,pc),d0
		lsl	#2,d0
		movea.l	(a3,d0.w),a1
		moveq	#0,d2
		move.b	(a1)+,d2		;J[\s̃oCg

		move	(cursorXbyte,pc),d1
		adda	d1,a1
		EndChk2	a1
		cmpi.b	#CR,(a1)
		beq	forward_word_end
		tst.b	d4
		beq	@f
		cmpi.b	#SPACE,(a1)		L(or)Ԃ
		bhi	forward_word_end	PƌȂ
@@:
		tst.b	(a1)
		bpl	@f
		cmpi.b	#$a0,(a1)
		bcs	forward_word_mb		$80-$7f
		cmpi.b	#$e0,(a1)
		bcs	@f			$e0-$ff
forward_word_mb:
		addq	#1,d1
@@:
		addq	#1,d1
		cmp	d1,d2
		bne	forward_word_loop
		movea.l	(a3,d0.w),a1		J[\E[ɂꍇ
		adda	d1,a1
		addq.l	#1,a1
		EndChk2	a1
		tst.b	(a1)+
		beq	@f
		EndChk	a1
		tst.b	(a1)+
		bne	key_forward_word
@@:
forward_char_end:
		rts

*  , ̑ : J[\ꌅEɈړ
key_forward_char:
		lea	(cursorX,pc),a0
		move	(a0)+,d3		;cursorX
		move	(a0)+,d2		;cursorXbyte
		move	(a0),d7			;cursorY

		bsr	get_cursor_line_buffer
		bmi	forward_char_end
		moveq	#0,d1
		move.b	(a1)+,d1
		beq	forward_char_end

		adda	d2,a1
		EndChk2	a1
		bsr	get_char
		cmp	d1,d2
		beq	cursor_to_right_tip

		subq.l	#cursorY-cursorX,a0
		move	d3,(a0)+
		move	d2,(a0)
		.ifndef	__EMACS
* J[\ړɔ}[N]̈̕ύXǏ]
redraw_cursor_char:
		bsr	draw_char_c
		move.l	(cursorX,pc),d6		cursorX/Xbyte
		move	(cursorY,pc),d7
		bra	draw_char_c
		.endif
cursor_to_right_endofbuf:
		rts

cursor_to_right_tip:
		tst.b	(a1)+
		beq	cursor_to_right_endofbuf
		EndChk	a1
		tst.b	(a1)
		beq	cursor_to_right_endofbuf

		subq.l	#cursorY-cursorX,a0
		clr.l	(a0)+

		move	(window_line,pc),d0
		cmp	(a0),d0			;cursorY
		bne	@f

		bsr	scroll_up_sub
		subq	#1,d7
		move	(window_line,pc),d0
		.ifdef	__EMACS
			bra	draw_line_d0
		.else
			bsr	draw_line_d0
			bra	redraw_cursor_char
		.endif
@@:
		addq	#1,(a0)			cursorY
		.ifdef	__EMACS
			rts
		.else
			bra	redraw_cursor_char
		.endif

* Z , ^Z , ~ : sXN[Abv
key_move_window_down:
		lea	(line_buf,pc),a3
		tst.l	(a3)
		bmi	move_window_down_end

		move	(window_line,pc),d0
		lsl	#2,d0
		movea.l	(a3,d0.w),a1
		moveq	#0,d1
		move.b	(a1)+,d1
		adda	d1,a1
		EndChk2	a1
		tst.b	(a1)+
		beq	move_window_down_end
		EndChk	a1
		tst.b	(a1)
		beq	move_window_down_end

		bsr	scroll_up_sub
		lea	(cursorY,pc),a4
		tst	(a4)
		beq	@f

		subq	#1,(a4)			cursorY
		bra	move_window_down_cursor_fixed
@@
		bsr	check_column
		.ifndef	__EMACS
			moveq	#0,d0
			bsr	draw_line_d0
		.endif
move_window_down_cursor_fixed:
		move	(window_line,pc),d0
		bra	draw_line_d0
move_window_down_end:
		rts

* X , ^X ,  : J[\ړ
key_next_line:
		lea	(line_buf,pc),a3
		lea	(cursorY,pc),a2
		move	(a2),d0
		cmp	(window_line,pc),d0
		beq	next_line_scroll

		addq	#1,d0
		lsl	#2,d0
		tst	(a3,d0.w)
		bmi	next_line_end
		addq	#1,(a2)			cursorY
		bsr	check_column
		move	(a2),d0			cursorY
		bra	next_line_no_scroll

next_line_scroll:
		lsl	#2,d0
		movea.l	(a3,d0.w),a1
		moveq	#0,d1
		move.b	(a1)+,d1
		adda	d1,a1
		EndChk2	a1
		tst.b	(a1)+			;ȂĂǂ?
		beq	next_line_end		;
		EndChk	a1
		tst.b	(a1)
		beq	next_line_end
		bsr	scroll_up_sub
		bsr	check_column
		move	(window_line,pc),d0
next_line_no_scroll:
		.ifdef	__EMACS
			bra	draw_line_d0
		.else
			bsr	draw_line_d0
			subq	#1,d0
			bra	draw_line_d0
		.endif
next_line_end:
move_window_up_end:
		rts

* W , ^W , ~ : sXN[_E
key_move_window_up:
		lea	(line_buf,pc),a3
		movea.l	(a3),a1
		move.l	a1,d0
		bmi	move_window_up_end	;obt@

		subq.l	#1,a1
		TopChk	a1
		moveq	#0,d0
		move.b	(a1),d0
		beq	move_window_up_end
		bsr	scroll_down_sub
		move	(window_line,pc),d0
		lea	(cursorY,pc),a4
		cmp	(a4),d0
		beq	@f

		addq	#1,(a4)
		bra	move_window_up_cursor_fixed
@@
		bsr	check_column
		.ifndef	__EMACS
			move	(a4),d0		cursorY
			bsr	draw_line_d0
		.endif
move_window_up_cursor_fixed:
		moveq	#0,d0
		bra	draw_line_d0

* E , ^E ,  : J[\ړ
key_previous_line:
		lea	(line_buf,pc),a3
		lea	(cursorY,pc),a0
		subq	#1,(a0)
		.ifdef	__EMACS
			bpl	check_column
		.else
			bpl	previous_line_no_scroll
		.endif
		clr	(a0)
		movea.l	(a3),a1
		move.l	a1,d0
		bmi	previous_line_end	;obt@͋

		subq.l	#1,a1
		TopChk	a1
		moveq	#0,d0
		move.b	(a1),d0
		beq	previous_line_end

		bsr	scroll_down_sub
		bsr	check_column
		moveq	#0,d0
		.ifdef	__EMACS
			bra	draw_line_d0
		.else
			bra	@f
previous_line_no_scroll:
			bsr	check_column
			move	(a0),d0
@@
			bsr	draw_line_d0
			addq	#1,d0
			bra	draw_line_d0
		.endif
previous_line_end:
backward_char_end:
		rts

* \ʂ̍ɂꍇ̓XN[Ă珑
backward_char_prev_line:
		addq	#1,(a4)			;cursorY

		subq.l	#1,a1
		TopChk	a1
		moveq	#0,d0
		move.b	(a1),d0
		beq	backward_char_end

		bsr	scroll_down_sub
		addq	#1,(a4)			;cursorY
		moveq	#0,d0
		bsr	draw_line_d0

* S , ^S ,  : J[\ړ
key_backward_char:
		lea	(cursorX,pc),a4
		move.l	(a4)+,d6		;cursorX/Xbyte
		move	(a4),d7			;cursorY
		moveq	#0,d2
		moveq	#0,d3
		bsr	get_cursor_line_buffer
		bmi	backward_char_end

		move	(cursorXbyte,pc),d1
		bne	@f

		subq	#1,(a4)			;cursorY
		bmi	backward_char_prev_line

		bsr	get_cursor_line_buffer
		moveq	#0,d1
		move.b	(a1),d1
@@:
		addq.l	#1,a1
		EndChk	a1
@@:
		move	d3,d4
		swap	d4
		move	d2,d4
		bsr	get_char
		cmp	d2,d1
		bne	@b
		move.l	d4,-(a4)		;cursorX/Xbyte
		.ifdef	__EMACS
			rts
		.else
			bra	redraw_cursor_char
		.endif

* ^A : s̍[Ɉړ
key_beginning_of_line:
			lea	(cursorX,pc),a0
			clr.l	(a0)+		;cursorX/Xbyte
		.ifdef	__EMACS
			rts
		.else
			lea	(line_buf,pc),a3
			move	(a0),d0		;cursorY
			bra	draw_line_d0
		.endif

* ROLL_DOWN , ^R : XN[_E
key_scroll_down:
		lea	(line_buf,pc),a3
		movea.l	(a3),a0
		move	(window_line,pc),d1
		move	d1,d0
		addq	#1,d0
		lsl	#2,d0
		adda	d0,a3			;a3=&line_buf[Ō+1]

		moveq	#-1,d2
		bsr	scroll_down_p_sub
		addq	#1,d2
		beq	key_beginning_of_page	;擪sɂꍇ͍Ɉړ
		bsr	check_column
		bra	draw_backscroll

* ROLL_UP , ^C : XN[Abv
key_scroll_up:
		lea	(line_buf,pc),a3
		move	(window_line,pc),d1
		move	d1,d0
		lsl	#2,d0
		move.l	(a3,d0.w),d0
		bmi	key_end_of_buffer	;1ŕɍsȂ

		movea.l	d0,a0			;a0=ŏIs̃AhX
		move	d1,d2
scroll_up_loop:
		moveq	#0,d0
		move.b	(a0)+,d0
		adda	d0,a0
		EndChk2	a0

		tst.b	(a0)+
		beq	@f			;̍sobt@ŏIs
		EndChk	a0

		tst.b	(a0)
@@:		beq	key_end_of_buffer	;sȂŌ̍s͓Ȃ

		move	d1,d0
		movea.l	a3,a1
		lea	(4,a1),a2
		subq	#1,d0
@@:
		move.l	(a2)+,(a1)+
		dbra	d0,@b
		move.l	a0,(a1)
		dbra	d2,scroll_up_loop
		bsr	check_column
		bra	draw_backscroll

* M-< , C-rolldown : set-mark + beginning-of-buffer
		.ifdef	__EMACS
key_beginning_of_buffer_mark:
			bsr	key_set_mark_quiet
		.endif
* T , F0 : obt@̐擪sɈړ
key_beginning_of_buffer:
		bsr	beginning_of_buffer_sub
* ^T : J[\ݕ\̉ʂ̍Ɉړ
key_beginning_of_page:
		lea	(cursorX,pc),a0
		clr.l	(a0)+			cursorX/Xbyte
		clr	(a0)			cursorY
		bra	draw_backscroll

* M-> , C-rollup : set-mark + end-of-buffer
		.ifdef	__EMACS
key_end_of_buffer_mark:
			bsr	key_set_mark_quiet
		.endif
* B , F1 : obt@̍ŏIsɈړ
key_end_of_buffer:
		bsr	end_of_buffer_sub
jump_to_page_end:
		lea	(cursorY,pc),a0
		st	(cursorX-cursorY,a0)
		move	d2,(a0)
		bpl	@f

		clr	(a0)
@@:
		bsr	check_column		ǑʒuɊ֌WȂE[Ɉړ
		bra	draw_backscroll

* ^B : J[\ݕ\̉ʂ̉EɈړ
key_end_of_page:
		lea	(line_buf,pc),a3
		movea.l	a3,a0
		moveq	#-1,d2
@@:
		tst.l	(a0)+
		bmi	@f			obt@
		addq	#1,d2
		cmp	(window_line,pc),d2
		bne	@b
@@:
		bra	jump_to_page_end

* ^F : s̉E[Ɉړ
key_end_of_line:
		bsr	get_cursor_line_buffer
		bmi	end_of_line_end

		move	(cursorXbyte,pc),d2
		move	(cursorX,pc),d3
		moveq	#0,d1
		move.b	(a1)+,d1		d1=oCg
		adda	d2,a1			d2=cursorXbyte
		EndChk2	a1
@@:
		move	d3,d4			d3=cursorX
		swap	d4
		move	d2,d4
		bsr	get_char
		cmp	d1,d2
		bne	@b

		lea	(cursorX,pc),a0
		move.l	d4,(a0)+		cursorX/Xbyte
		.ifndef	__EMACS
			move	(a0),d0		cursorY
			bra	draw_line_d0
		.endif
end_of_line_end:
		rts

* ^J , ^] , HELP : wv\
key_help:
		lea	(bitflag,pc),a0
		tas	(a0)			HELPMODE_bit
		bmi	already_help

		move.l	(line_buf,pc),-(sp)
		lea	(buffer_size,pc),a0
		move.l	(a0),-(sp)		wvbZ[W̗e
		move.l	#help_mes_end-help_mes_top,(a0)+
		move.l	(a0),-(sp)		;mark_char_adr
		clr.l	(a0)+
		move.l	(a0),-(sp)		;mark_line_adr
		clr.l	(a0)+
		move.l	(a0),-(sp)		cursorX/Byte
		clr.l	(a0)+
		move	(a0),-(sp)		cursorY
		clr	(a0)

		move.l	a6,-(sp)
		lea	(help_buf_struct,pc),a6
		bsr	key_beginning_of_buffer

		.ifndef	__EMACS
			move.b	(ins_clr_flag,pc),-(sp)
			bsr	clr_ins_led
		.endif

		bsr	keyinp_loop
		lea	(cursorY,pc),a0

		.ifndef	__EMACS
			bsr	restore_ins_led
			move.b	(sp)+,(ins_clr_flag-cursorY,a0)
		.endif

		movea.l	(sp)+,a6
		bclr	#HELPMODE_bit,(bitflag-cursorY,a0)
		move	(sp)+,(a0)
		move.l	(sp)+,-(a0)		;cursorX
		move.l	(sp)+,-(a0)		;mark_line_adr
		move.l	(sp)+,-(a0)		;mark_char_adr
		move.l	(sp)+,-(a0)		buffer_size

		movea.l	(sp)+,a0
		bsr	reset_line_address_buf_2
		bsr	draw_backscroll
		bra	initialize_keypast_buffer
already_help:
insert_file_cancel:
		rts

* ǉ@\ -------------------------------------

* C-bs : obt@O~EĊJ

key_toggle_buffering_mode:
		lea	(condrv_put_char,pc),a0
		eori	#RTS.xor.MOVEM,(a0)	;obt@荞ݒ~/ĊJgO
		bra	display_system_status

* C-clr : obt@

key_clear_buffer:
		lea	(mark_char_adr,pc),a0
		clr.l	(a0)+			;mark_char_adr
		clr.l	(a0)+			;mark_line_adr

		bsr	initialize_backscroll_buffer
		bra	key_beginning_of_buffer

* ^Y : t@Cǂݍ
key_insert_file:
		move.b	(bitflag,pc),d0
		bmi	insert_file_cancel	HELP\͎gps

		lea	(insert_file_prompt,pc),a1
		bsr	input_string
		beq	insert_file_cancel
		bsr	check_diskready
		bmi	disk_notready_error

		clr	-(sp)
		move.l	a1,-(sp)
		DOS	_OPEN
		addq.l	#6,sp
		move.l	d0,d4
		bmi	fileopen_error

		moveq	#6,d1
		bsr	is_file_io_enable
		bne	fileread_disable

		lea	(io_buffer,pc),a5
		lea	(REQHEAD_SIZE,a5),a0
		move.l	a0,(DEVIO_ADDRESS,a5)
insert_file_loop:
		pea	(IOBUFSIZE)
		move.l	a0,-(sp)
		move	d4,-(sp)
		DOS	_READ
		lea	(10,sp),sp
		move.l	d0,(DEVIO_LENGTH,a5)
		ble	insert_file_end
		bsr	xcon_output
		bra	insert_file_loop
insert_file_end:
		bsr	close_filehandle_d4
		bsr	clear_mark		* _and_redraw
		bra	key_end_of_buffer

close_filehandle_d4:
		move	d4,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
		rts

* o͉\Ȃ d0.b=0
is_file_io_enable:
		move	d4,-(sp)
		clr	-(sp)
		DOS	_IOCTRL
		asr.b	#8,d0
		bpl	@f

		move	d1,(sp)
		DOS	_IOCTRL
		not.b	d0
@@
		addq.l	#4,sp
		rts

* in	a1.l	t@C
*	d0.l	0:OK -1:Error
check_diskready:
		lea	(GETSMAX+1,a1),a0
		move.l	a0,-(sp)
		move.l	a1,-(sp)
		DOS	_NAMECK
		addq.l	#8,sp
		tst.l	d0			uChJ[hwȂvOK
		bne	nocheck_diskready	̓I[vɃG[
		moveq	#0,d1
@@		move.b	(a0),d1
		subi.b	#'A'-1,d1		DRVCTRLhCu

		clr.b	(2,a0)
		move.l	a0,-(sp)
		move.l	a0,-(sp)
		clr	-(sp)
		DOS	_ASSIGN
		lea	(10,sp),sp
		cmpi	#$50,d0
		beq	@b			zhCu̐eǂ

		move	d1,-(sp)		MD=0
		DOS	_DRVCTRL
		addq.l	#2,sp
		tst.l	d0
		bmi	disk_notready
		lsr	#1,d0
		bcs	disk_notready		fBA}
		lsr	#1,d0
		bcc	disk_notready		}ĂȂ
nocheck_diskready:
		moveq	#0,d0
		rts
disk_notready:
		moveq	#-1,d0
		rts

filewrite_disable:
		move	#'o',d0
		bra	@f
fileread_disable:
		move	#'',d0
@@
		lea	(file_io_disable_mes,pc),a1
		move	d0,(a1)
		bsr	close_filehandle_d4
		bra	1f

fileopen_error:
		lea	(fopen_err_mes_tbl,pc),a1
		move.b	d0,(fopen_err_mes-fopen_err_mes_tbl,a1)
check_open_err:
		cmp.b	(a1)+,d0
		beq	1f
@@		tst.b	(a1)+
		bne	@b
		bra	check_open_err

disk_notready_error:
		lea	(disk_notready_mes,pc),a1
1:
		bra	print_message

		.ifndef	__EMACS
* L : x`(J[\ʒu͍[)
key_set_label:
		lea	(define_label_mes,pc),a0
		moveq	#0,d0
		bsr	print_label_mes
		bsr	get_key_a_z
		bhi	define_label_end

		lsl	#2,d0
		lea	(label_buffer,pc),a0
		adda	d0,a0			i[

		move	(cursorY,pc),d0
		lsl	#2,d0
		lea	(line_buf,pc),a1
		adda	d0,a1			ۑ

		move.l	(a1),(a0)+
define_label_end:
jump_label_end:
		rts

* Shift + 7 (') : w胉x܂ňړ
key_jump_label:
		lea	(jump_label_mes,pc),a0
		moveq	#-1,d0
		bsr	print_label_mes
		bsr	get_key_a_z
		bhi	jump_label_end

		lsl	#2,d0
		lea	(label_buffer,pc),a0
		adda	d0,a0
		move.l	(a0),d1
		beq	jump_label_end		`̃x
		movea.l	d1,a0			Jump

		movea.l	(buffer_now,a6),a1
		bra	@f
jump_label_loop
		move.b	-(a1),d0
		beq	jump_label_end		obt@̐擪܂ōs
		subq.l	#1,a1
		suba	d0,a1
		TopChk	a1
@@:
		cmpa.l	a0,a1
		bne	jump_label_loop

		moveq	#0,d2
		moveq	#0,d3
		bra	jump_scroll

print_label_mes:
		lea	(general_work,pc),a1
		bsr	str_copy

		moveq	#'A',d1
		lea	(label_buffer,pc),a0
label_print_loop:
		tst.l	(a0)+
		sne	-(sp)
		cmp.b	(sp)+,d0
		bne	@f

		move.b	d1,(a1)+
@@
		addq.b	#1,d1
		cmpi.b	#'Z',d1
		bls	label_print_loop

		lea	(label_mes_end,pc),a0
		bsr	str_copy
		lea	(general_work,pc),a1
		bra	print_message

get_key_a_z:
		bsr	get_key_sub
		ori	#$20,d0
		subi	#'a',d0
		cmpi	#'z'-'a',d0
		rts

		.endif

str_copy:
		move.b	(a0)+,(a1)+
		bne	str_copy
		subq.l	#1,a1
		rts

get_key_sub:
		suba.l	a1,a1
get_key_sub_loop:
		IOCS	_ONTIME
		cmp.l	a1,d0
		bcs	@f

		bsr	blink_cursor_direct
		IOCS	_ONTIME
		lea	(BLINKCYCLE),a1
		adda.l	d0,a1
@@
		bsr	call_orig_b_keysns
		tst.l	d0
		beq	get_key_sub_loop

		bsr	call_orig_b_keyinp
		tst.b	d0
		beq	get_key_sub_loop
		bra	clear_message		vvg

* Q : ݒύX
key_toggle_buffer_mode:
		lea	(toggle_buffer_mode_mes,pc),a1
		bsr	print_message
		bsr	get_key_sub
		ori.b	#$20,d0

		.irpc	%a,trbeicx
		cmpi.b	#'&%a',d0
		beq	toggle_buffer_mode_%a
		.endm
		rts

* \ԂςtO
toggle_buffer_mode_t:
		lea	(option_t_flag,pc),a0	Tab\
		bra	@f
toggle_buffer_mode_r:
		lea	(option_r_flag,pc),a0	R:s\
		bra	@f
@@:
		not.b	(a0)
		bra	draw_backscroll

* \ɂ͊֌WȂtO

* B(-nb:BS)
toggle_buffer_mode_b:
toggle_option_nb:

PUT_BS_TBL:	.reg	(putbuf_ctrl_table+BS*2)
PUT_BS:		.equ	putbuf_bs-PUT_BS_TBL
PUT_BS_NB:	.equ	putbuf_bs_nb-PUT_BS_TBL

		lea	(PUT_BS_TBL,pc),a0
		eori	#PUT_BS.xor.PUT_BS_NB,(a0)

		not.b	(option_nb_flag-PUT_BS_TBL,a0)
		rts

* E(-ne:ESC폜)
toggle_buffer_mode_e:
toggle_option_ne:

PUT_ESC_TBL:	.reg	(putbuf_ctrl_table+ESC*2)
PUT_ESC:	.equ	putbuf_esc-PUT_ESC_TBL
PUT_ESC_NE:	.equ	putbuf_esc_ne-PUT_ESC_TBL

		lea	(PUT_ESC_TBL,pc),a0
		eori	#PUT_ESC.xor.PUT_ESC_NE,(a0)

		not.b	(option_ne_flag-PUT_ESC_TBL,a0)
		rts

* I(-nt:TABϊ)
toggle_buffer_mode_i:
toggle_option_nt:

PUT_TAB_TBL:	.reg	(putbuf_ctrl_table+TAB*2)
PUT_TAB:	.equ	putbuf_tab-PUT_TAB_TBL
PUT_TAB_NT:	.equ	putbuf_tab_nt-PUT_TAB_TBL

		lea	(PUT_TAB_TBL,pc),a0
		eori	#PUT_TAB.xor.PUT_TAB_NT,(a0)

		not.b	(option_nt_flag-PUT_TAB_TBL,a0)
		rts

* C(-nc:L폜)
toggle_buffer_mode_c:
toggle_option_nc:

PUT_CTRL:	.equ	   putbuf_ctrl-putbuf_ctrl_table
PUT_CTRL_NC:	.equ	putbuf_ctrl_nc-putbuf_ctrl_table

		move	#PUT_CTRL,d1
		move	#PUT_CTRL_NC,d2

		move.l	#PUT_CTRL_LIST,d0
		lea	(putbuf_ctrl_table,pc),a0
toggle_option_nc_loop:
		lsr.l	#1,d0
		bcc	@f

		eor	d1,(a0)
		eor	d2,(a0)
@@:
		addq.l	#2,a0
		subq	#2,d1
		subq	#2,d2

		tst.l	d0
		bne	toggle_option_nc_loop

		lea	(option_nc_flag,pc),a0
		not.b	(a0)
		rts

toggle_buffer_mode_x:
		lea	(case_table+'a',pc),a0	X:̑啶̋ON/OFF؂芷
		not.b	(option_x_flag-(case_table+'a'),a0)

		moveq	#'z'-'a',d0
1:		eori.b	#$20,(a0)+
		dbra	d0,1b
		rts

* Shift + Q : ݒύX̂Q(-m?)
key_toggle_text_mode:
		lea	(toggle_text_mode_mes,pc),a1
		bsr	print_message
		bsr	get_key_sub
		cmpi.b	#'1',d0
		beq	toggle_text_mode_1
		cmpi.b	#'2',d0
		beq	toggle_text_mode_2
		cmpi.b	#'3',d0
		beq	toggle_text_mode_3
		rts

toggle_text_mode_1:
		moveq	#0,d0			1:}EX
		bra	@f
toggle_text_mode_2:
		moveq	#1,d0			2:eLXgۑ
@@:
		lea	(option_m_flag,pc),a0
		bchg	d0,(a0)
toggle_text_mode_3_end:
		rts
toggle_text_mode_3:
		lea	(option_m_flag,pc),a0	3:eLXggp󋵖
		bchg	#2,(a0)
		bne	toggle_text_mode_3_end

gm_tgusemd_orig_tm1:
		moveq	#1,d2
gm_tgusemd_orig:
		move.l	#_GM_INTERNAL_MODE<<16+1,d1
		IOCS	_TGUSEMD
		rts

* sXN[ă[NXV` -----------

* in	d0.w	Vŏis̃oCg
*	a1.l	V		̃oCgi[ʒu
*	a3.l	line_buf

scroll_down_sub:
		movea.l	a3,a0
		move	(window_line,pc),d2
		move	d2,d1
		addq	#1,d1
		lsl	#2,d1
		adda	d1,a0
		lea	(-4,a0),a2
		move	d2,d1
		subq	#1,d1
@@
		move.l	-(a2),-(a0)
		dbra	d1,@b
		suba	d0,a1
		subq.l	#1,a1
		TopChk	a1
		move.l	a1,(a2)

		move	d2,d0
		lsl	#2,d0			d0Ӗ̂Œ
		move.b	d0,d1
		subq	#1,d1
		lsl	#8,d1
		move.b	d0,d1
		addq.b	#4-1,d1
		add	(text_ras_no,pc),d1
		bra	rascpy_down

scroll_up_sub:
		movea.l	a3,a0
		move	(window_line,pc),d0
		subq	#1,d0
		lea	(4,a0),a2
@@
		move.l	(a2)+,(a0)+
		dbra	d0,@b
		move.l	a1,(a0)
		bra	rascpy_up_all

* ܂łƓJ[\ʒu܂ŉEɈړ ---

check_column:
		lea	(cursorX,pc),a4
		moveq	#0,d1
		moveq	#0,d2
		moveq	#0,d3
		moveq	#0,d4
		bsr	get_cursor_line_buffer
		bmi	check_column_end

		move.b	(a1)+,d1
		EndChk	a1
check_column_loop:
		cmp	d1,d2
		beq	check_column_end
		move	d3,d4
		swap	d4
		move	d2,d4
		bsr	get_char
		cmp	(a4),d3			;cursorX
		bls	check_column_loop
check_column_end:
		move.l	d4,(a4)
		rts

* ꕶ ------------------------------ *
*	d0.w	
*	d2.w	s̃oCg
*	d3.w	š(2oCgp1ƂĊZ)
*	a1.l	obt@|C^

get_char:
		moveq	#0,d0
		move.b	(a1)+,d0
		beq	get_char_endofbuf
		addq	#1,d2
		EndChk	a1
		tst.b	d0
		bpl	@f
		cmpi.b	#$a0,d0
		bcs	get_char_2byte
		cmpi.b	#$e0,d0
		bcs	@f
get_char_2byte:
		lsl	#8,d0
		addq	#1,d2
		move.b	(a1)+,d0
		EndChk	a1
@@:
		cmpi	#TAB,d0
		bne	@f
		ori	#7,d3
@@:
		addq	#1,d3
		cmpi	#$8140,d0
		bcs	@f
		cmpi	#$8540,d0
		bcs	get_char_wide		8140`853f܂őSp
		cmpi	#$869f,d0
		bcs	@f
		cmpi	#$f000,d0
		bcc	@f
get_char_wide:
		addq	#1,d3			869f`efff܂őSp
@@		rts

get_char_endofbuf:
		subq.l	#1,a1
		rts

* X^Rs[Ăяo -------------------------

rascpy_up_all:
		move	(window_line,pc),d0
		move	#$0400,d1
rascpy_up_shl2:
		lsl	#2,d0
rascpy_up:
		add	(text_ras_no,pc),d1	X^ԍ
		move	#$101,d2
		bra	@f
rascpy_down:
		move	#$feff,d2
@@:
		move.l	a3,-(sp)
		lea	(CRTC_R21),a3
		move	(a3),-(sp)
		move	#%1_0000_1100,(a3)
		bsr	txrascpy_sub
		move	(sp)+,(a3)
		movea.l	(sp)+,a3
		rts

* obNXN[ʂ̍ŉsčs͂
* in	a1.l	vvgƂĕ\镶
* out	a1.l	̓obt@̐擪+2(͂ꂽ)
*	ccrZ	͕ 0 Ȃ ccrZ=1
input_string:
usereg:		.reg	d1-d7/a2-a5
		PUSH	usereg
		lea	(condrv_put_char,pc),a5
		move	(a5),-(sp)
		move	#RTS,(a5)
		bset	#GETSS_bit,(bitflag-condrv_put_char,a5)

		move.l	(TXADR),-(sp)		IOCSworkҔ
		move.l	(TXSTOFST),-(sp)
		move.l	(CSRXMAX),-(sp)		& CSRYMAX
		move.l	(CSRX),-(sp)		& CSRY
		move.b	(FIRSTBYTE),-(sp)
		move.b	(TXCOLOR),(1,sp)
		move.b	(LEDSTAT),-(sp)

;eLXgҔ
		move	(window_line,pc),d0
		add	(down_line,pc),d0
		addq	#2,d0
		move	d0,-(sp)		;!
		mulu	#(128*16),d0

		lea	(TEXT_VRAM),a2
		move.l	a2,(TXADR)		;T-VRAMAhX(v[̎w)
		move.l	d0,(TXSTOFST)		;\AhXItZbg
		adda.l	d0,a2
		lea	(line_store_buf+128*16*2,pc),a3
		bsr	move_textblock		;plane0Ҕ
		adda.l	#$20000-128*16,a2
		bsr	move_textblock		;     1
*		move.l	a2,-(sp)
*		move.l	a3,-(sp)

;YsNA
		move.l	#(WIDTH-1).shl.16+0,(CSRXMAX)
		clr.b	(FIRSTBYTE)
		moveq	#2,d1
		IOCS	_B_CLR_ST		ʑŜ
		move.b	#2,(TXCOLOR)		ŕ\
		IOCS	_B_PRINT		prompt
		addq.b	#1,(TXCOLOR)		

		move	(sp)+,d1		;!
		lsl	#2,d1
		moveq	#4-1,d2
		bsr	clear_text_raster_m4	;͍s̃}EXv[NA

		bsr	gm_inactive
		bsr	fep_enable

		IOCS	_OS_CURON

		lea	(general_work,pc),a1
		move	#GETSMAX.shl.8,(a1)
		move.l	a1,-(sp)
		DOS	_GETSS
		addq.l	#4,sp

		IOCS	_OS_CUROF

		bsr	fep_disable
		bsr	gm_active

* ҔeLXgɖ߂
*		movea.l	(sp)+,a2
*		movea.l	(sp)+,a3
		exg	a2,a3
		bsr	move_textblock		v[1 𕜋A
		suba.l	#$20000-128*16,a3
		bsr	move_textblock		V	0

		move.b	(sp)+,(LEDSTAT)
		IOCS	_LEDSET
		move.b	(1,sp),(TXCOLOR)	IOCSworkA
		move.b	(sp)+,(FIRSTBYTE)
		move.l	(sp)+,(CSRX)
		move.l	(sp)+,(CSRXMAX)
		move.l	(sp)+,(TXSTOFST)
		move.l	(sp)+,(TXADR)
		move	(sp)+,(a5)
		bclr	#GETSS_bit,(bitflag-condrv_put_char,a5)

		lea	(general_work+1,pc),a1
		tst.b	(a1)+			͕
		POP	usereg
		rts

move_textblock:
		moveq	#(128*16)/(4*8)-1,d0
@@
		movem.l	(a2)+,d1-d7/a4
		movem.l	d1-d7/a4,-(a3)
		dbra	d0,@b
		rts

; GM 풓ĂꎞIɓ~. d0/a1 j
gm_inactive:
		GMcall	_GM_VERSION_NUMBER
		move	d0,-(sp)		(sp)==0 ŏI Activate
		bne	@f			풓

		GMcall	_GM_ACTIVE_STATE
		swap	d0
		not	d0			d0.hw==0 Œ~
		move	d0,(sp)
		bne	@f			~

		GMcall	_GM_INACTIVE
@@
		tst	(sp)+
		lea	(gm_automask,pc),a1
		seq	(a1)
		rts

; GM ~Ă瓮ĊJ
gm_active:
		move.b	(gm_automask,pc),d0
		bne	@f			풓ĂȂA֎~ĂȂ
		GMcall	_GM_ACTIVE
@@
		bra	clear_message

* obNOʍŉs̕ ------ *

clear_message:
usereg:		.reg	d0-d3/a1
		PUSH	usereg

		move.b	(down_line+1,pc),-(sp)
		move	(sp),d1
		move.b	(sp)+,d1
		add.b	(window_line+1,pc),d1
		addq	#2,d1
		lsl	#2,d1
		moveq	#1,d2
		moveq	#%1100,d3
		IOCS	_TXRASCPY

		move.b	d1,-(sp)
		move	(sp),d1
		move.b	(sp)+,d1
		addq.b	#1,d1			;ɃRs[
		moveq	#3,d2
		IOCS	_TXRASCPY

		lea	(mes_end_adr,pc),a1
		clr.l	(a1)
		POP	usereg
		rts

; in	d1.w	@\ԍ(d1.hw=-1)
; out	d0.hw	Ԓl
gm_tgusemd:
		addi.l	#(_GM_INTERNAL_MODE+1).shl.16,d1
		IOCS	_TGUSEMD
		subi	#_GM_INTERNAL_MODE,d0
		rts

* FEP I[vo悤ɂ
fep_enable:
		lea	(fepctrl_mode,pc),a4
		clr.l	(a4)
		pea	(2)			Ȋϊ[h̎
		DOS	_KNJCTRL
		btst	#FEPOPEN_bit,(bitflag,pc)
		beq	@f
		move.l	d0,(a4)			ȑÔȊϊ[h
@@
*		pea	(8)			Ȋϊ[hŒԂ̎
		addq.l	#8-2,(sp)
		DOS	_KNJCTRL
		move.l	d0,-(a4)		fepctrl_lock
*		pea	(1)			Œ
		subq.l	#8-1,(sp)
		pea	(7)
		DOS	_KNJCTRL
		addq.l	#8,sp
		rts

* FEP ̏Ԃɖ߂
fep_disable:
		lea	(fepctrl_lock,pc),a4
		move.l	(a4)+,-(sp)
		pea	(7)
		DOS	_KNJCTRL		bN[hɖ߂
		btst	#FEPOPEN_bit,(bitflag,pc)
		beq	@f
		move.l	(a4),(4,sp)		fepctrl_mode
		subq.l	#7-1,(sp)
		DOS	_KNJCTRL		ϊ[hɖ߂
@@
		addq.l	#8,sp
		rts

* ŉsbZ[W\/ ----------- *

* ȑO̕\̍Ōォǉŕ\
print_message_cont:
usereg		.reg	d0-d2/a0-a2
		PUSH	usereg
		movea.l	(mes_end_adr,pc),a0
		bra	print_m_loop

* obNOʍŉsɕ\
* in	a1.l = \镶
print_message:
		PUSH	usereg
		movea.l	(text_address,pc),a0
		move	(window_line,pc),d0
		swap	d0
		clr	d0
		lsr.l	#5,d0		*128*16
		adda.l	d0,a0		pXy[X\Ƃɂ
		lea	(128*(16+8)+1,a0),a0
print_m_loop:
		move	a0,d0
		cmpi.b	#WIDTH,d0	ʉE[܂łAȏ\Ȃ
		bcc	print_message_end

		moveq	#0,d1
		move.b	(a1)+,d1
		beq	print_message_end
		lea	(ctype_table,pc),a2
		tst.b	(a2,d1.w)	MULTIBYTE
		bpl	@f		1byte

		lsl	#8,d1
		move.b	(a1)+,d1
		beq	print_message_end
@@
		moveq	#8,d2
		IOCS	_FNTADR
		movea.l	d0,a2
		tst	d1
		bne	draw_multibyte
@@
		move.b	(a2)+,(a0)
		lea	(128,a0),a0
		dbra	d2,@b
		lea	(-128*16+1,a0),a0
		bra	print_m_loop
print_message_end:
		lea	(mes_end_adr,pc),a1
		move.l	a0,(a1)
		POP	usereg
		rts

draw_multibyte:
		move.b	(a2)+,(a0)+
		move.b	(a2)+,(a0)
		lea	(128-1,a0),a0
		dbra	d2,draw_multibyte
		lea	(-128*16+2,a0),a0
		bra	print_m_loop

* CONDRV.SYS System Call -----------------------

condrv_system_call:
usereg		.reg	d1-d7/a0-a6
		PUSH	usereg
		lea	(syscall_table,pc),a0
@@
		move	(a0)+,d2		address
		beq	syscall_error1
		cmp	(a0)+,d0		code
		bne	@b
		adda	d2,a0
		jsr	(a0)
syscall_return:
		POP	usereg
		rts
syscall_error1:
		moveq	#-1,d0
		bra	syscall_return

SYSTBL:		.macro	%callno
		.dc	syscall_%callno-($+4),$%callno
		.endm

syscall_table:
		SYSTBL	0000
		SYSTBL	0010
		SYSTBL	0020
		SYSTBL	0021
		SYSTBL	0022
		SYSTBL	0023
		SYSTBL	ffff
		.dc	0

syscall_0000:
		move	#RTS,d0
		tst	d1
		beq	@f
		move	#MOVEM,d0
@@
		lea	(condrv_put_char,pc),a1
		move	d0,(a1)
syscall_0010:
		moveq	#0,d0
		rts

syscall_0020:
		lea	(key_init_orig,pc),a0
		move.l	(a0),d0			̏AhX
		move.l	a1,(a0)			VAhXݒ
		rts

syscall_0021:
		lea	(key_init_orig,pc),a0
		cmpa.l	(a0),a1			݂̏AhX𐳂mĂ邩H
		bne	syscall_error2
		move.l	a2,(a0)			ȑÕAhXɖ߂
		moveq	#0,d0
		rts

syscall_0022:
		move.l	(key_init_orig,pc),d0
		rts

syscall_0023:
		lea	(bufmod_stack,pc),a0
		move.l	(a0)+,d0
		move.b	(a0),d3			bufmod_height
		tst	d1
		bne	syscall_0023_push

*		subq.b	#1,d3
*		bmi	syscall_0023_pop
		dbra	d3,syscall_0023_pop
syscall_error2:
		moveq	#-2,d0
		rts
syscall_0023_pop:
		move.b	d3,(a0)

		btst	d3,d0
		sne	d1
		ext	d1
		bra	syscall_0000
syscall_0023_push:
		cmpi.b	#31,d3
		beq	syscall_error2		X^bNtȂ̂ PUSH 悤Ƃ
		bset	d3,d0
		lea	(condrv_put_char,pc),a1
		cmpi	#RTS,(a1)
		bne	@f
		bchg	d3,d0
@@
		addq.b	#1,d3
		move.b	d3,(a0)
		move.l	d0,-(a0)
		moveq	#0,d0
		rts

syscall_ffff:
		move.l	#version2,d0
		rts

; foCX[` ---------------------- *

general_work:
xcon_init:
usereg		.reg	d1-d7/a0-a3/a6
		PUSH	usereg

* condrv.sysdo^ĂȂׂ
		clr	-(sp)
		pea	(xcon_filename,pc)
		DOS	_OPEN
		addq.l	#6,sp
		move.l	d0,d1
		bmi	double_check_ok

		move	d1,-(sp)
		clr	-(sp)
		DOS	_IOCTRL
		addq.l	#4,sp
		tst	d0
		lea	(double_include_err_mes,pc),a2
		bmi	print_error_and_return
double_check_ok:
		bsr	initialize_keypast_buffer
		lea	(option_flag,pc),a6

*ee[ȕ
		lea	(case_table+256,pc),a0
		move	#256-1,d0
@@:		move.b	d0,-(a0)
		dbra	d0,@b

		lea	(ctype_table+'0',pc),a0
		moveq	#10-1,d0
		moveq	#IS_HEXNUMBER+IS_DECIMAL,d1
@@:		move.b	d1,(a0)+
		dbra	d0,@b
		lea	(ctype_table+'A',pc),a0
		moveq	#6-1,d0
		moveq	#IS_HEXNUMBER,d1
@@:		move.b	d1,('a'-'A',a0)
		move.b	d1,(a0)+
		dbra	d0,@b

		lea	(ctype_table+$80,pc),a0
		moveq	#$20-1,d0
@@:		tas	($e0-$80,a0)		$e0-$ff
		tas	(a0)+			$80-$9f
		dbra	d0,@b

		lea	(end_,pc),a3
		move.l	a3,(DEVIO_ENDADR,a5)
		movea.l	(DEVIO_ARGUMENT,a5),a2
		bsr	option_check

		lea	(hook_table_top,pc),a0	exN^tbN
		move.l	(buffer_size,pc),d0
		bne	hook_loop_start		OK

		lea	(no_buf_err_mes,pc),a2	* -b w肳Ȃꍇ͏풓Ȃ
		move.b	(no_mem_flag,pc),d0
		beq	print_error_and_return
		lea	(no_mem_err_mes,pc),a2	* Ȃꍇ
print_error_and_return:
		bsr	print_title
		lea	(a2),a1
		jsr	(a3)
		move	#$700d,d0		G[̏ꍇ͂̒lԂ炵
		bra	devini_exit

hook_loop:
		movea	d0,a1
		move.l	(a0),d0
		move.l	(a1),(a0)+		݂̏AhXۑ
		lea	(top_,pc),a2
		adda	d0,a2
		move.l	a2,(a1)			VAhXݒ
hook_loop_start:
		move	(a0),d0
		bne	hook_loop

		bsr	print_title

		lea	(initmes1,pc),a1	obNXN[obt@`
		jsr	(a3)
		move.l	($1c00),d1		obt@擪AhX
		bsr	print_hexadecimal

		move	#'-',-(sp)
		DOS	_PUTCHAR

		moveq	#32,d1
		add.l	(buffer_size,pc),d1
		bsr	print_kiro_decimal

		lea	(initmes2,pc),a1
		btst	#BUFINIT_bit,(bitflag,pc)
		beq	@f
		lea	(initmes3,pc),a1	obt@ꍇ
@@		jsr	(a3)

		lea	(initmes4,pc),a1	L[{[hobt@`
		jsr	(a3)
		move.l	(pastbuf_adr,pc),d1
		bsr	print_hexadecimal

*		move	#'-',(sp)
		DOS	_PUTCHAR

		move.l	(pastbuf_size,pc),d1
		bsr	print_kiro_decimal

		lea	(initmes5,pc),a1	`mۂ܂
		jsr	(a3)

		move.l	#$e_ffff,-(sp)		! \
		DOS	_CONCTRL
		addq.l	#4+2,sp

		move.b	(option_o_flag,pc),d1
		subq.b	#3,d1			OPT.2
		bne	@f
		IOCS	$0b			OPT.2 ̓erRg[ɂȂ
@@
		moveq	#0,d0
devini_exit:
		POP	usereg
		rts

print_title:
		lea	(title_mes,pc),a1
		lea	(@f,pc),a3
@@:
		move.l	a1,-(sp)
		DOS	_PRINT
		addq.l	#4,sp
@@:
		rts

option_end:
		movea.l	(sp)+,a2
option_check:
		tst.b	(a2)+
		bne	option_check		̃t@Cor
		move.b	(a2)+,d0
		beq	@b			0,0 ŏI
		move.l	a2,-(sp)
		cmpi.b	#'-',d0
		bne	option_end
next_option:
		move.b	(a2)+,d0
		beq	option_end
		ori.b	#$20,d0
		lea	(option_tbl,pc),a0
@@
		move.l	(a0)+,d1
		beq	option_end		`̃IvV
		cmp.b	d0,d1
		bne	@b
		swap	d1
		adda	d1,a0
		jmp	(a0)
*ȂIvV͑ďƂł悤ɁA
*Ȉ			bra	next_option
*ُV(̈܂Ŗ)	bra	option_end

option_tbl:
		.irpc	%a,abcfhjkmnoprtvwx
		.dc	(option_%a-$-4),'&%a'
		.endm
		.dc.l	0

option_p:
		lea	(option_p_flag,pc),a0
		bra	@f
option_r:
		lea	(option_r_flag,pc),a0
		bra	@f
option_t:
		lea	(option_t_flag,pc),a0
		bra	@f
@@
		not.b	(a0)
		bra	next_option

option_x:
		bsr	toggle_buffer_mode_x
		bra	next_option

option_m:
		lea	(option_m_flag,pc),a0
		bsr	get_value
		bmi	@b			lȗ͔]
		move.b	d1,(a0)
		bra	next_option

option_n:
		move.b	(a2)+,d0
		beq	option_end
		ori.b	#$20,d0
		lea	(option_n_list,pc),a0

		cmp.b	(a0)+,d0		;-nb:BS 
		bne	@f
		bsr	toggle_option_nb
		bra	option_n
@@:
		cmp.b	(a0)+,d0		;-nc:L폜
		bne	@f
		bsr	toggle_option_nc
		bra	option_n
@@:
		cmp.b	(a0)+,d0		;-ne:ESC폜
		bne	@f
		bsr	toggle_option_ne
		bra	option_n
@@:
		cmp.b	(a0)+,d0		;-nt:TAB->SPACE
		bne	@f
		bsr	toggle_option_nt
@@:
		bra	option_n

option_a:
		lea	(ras_int_adr,pc),a0
		bra	@f
option_v:
		lea	(vdisp_int_adr,pc),a0
@@
		lea	(dummy_rte,pc),a1
		move.l	a1,(a0)
		bra	next_option

option_h:
		lea	(default_past_header,pc),a0
		move.b	(a2)+,d0
		beq	@f			ȗꍇ͍ŏ>ݒ肳Ă
		move.b	d0,(a0)
@@
		move.b	(a0),(past_header-option_flag,a6)
		bra	option_end

option_o:
		moveq	#$20,d0
		or.b	(a2)+,d0		;nul͕sv...

		lea	(option_o_list,pc),a0
		moveq	#3,d1
@@:
		cmp.b	(a0)+,d0
		dbeq	d1,@b
		bne	@f

		move.b	d1,(option_o_flag-option_flag,a6)
@@:		bra	option_end

option_c:
		move	#RTS,(condrv_put_char-option_flag,a6)
		bra	next_option		obt@荞ݒ~

option_f:
		moveq	#OPT_F_bit,d2
		bsr	get_value
		bmi	option_fj_chg		-f
		tst	d1
		beq	option_fj_chg		-f0

		move.b	d1,(option_f_col-option_flag,a6)	\Fw
		bra	@f

option_j:
		moveq	#OPT_J_bit,d2
option_fj_chg:
		bchg	d2,(a6)
@@		bra	next_option

option_b:
		cmpi.b	#'#',(a2)
		sne	d2			d2.b==0ŏ
		bne	@f
		addq.l	#1,a2
@@:
		bsr	get_value
		bmi	@f			;w
		move.l	(buffer_size,pc),d0
@@:
		bne	next_option		;wς

		mulu	#1024,d1		KBP
		movea.l	($1c00),a0		C
		suba.l	d1,a0
		bcs	@f
		lea	(a0),a1
		suba.l	(DEVIO_ENDADR,a5),a1
		bcs	@f
		cmpa.l	#$80000,a1
@@:
		scs	(no_mem_flag-option_flag,a6)
		bcs	@f			512KB cȂȂ疳
		moveq	#32,d0			Ǘ̕obt@͏ȂȂ
		sub.l	d0,d1
		bmi	@f			-b0 ̏ꍇ

		move.l	d1,(buffer_size-option_flag,a6)
		move.l	a0,($1c00)		
		move.l	a0,(backscroll_buf_adr-option_flag,a6)

		move.l	(buffer_now+4,a0),(line_buf-option_flag,a6)

		SFTbtst	SFT_SHIFT_bit
		bne	buffer_clear_start
		tst.b	d2			-b#n
		beq	buffer_clear_start
		cmpi.l	#'hmk*',(a0)
		beq	@f			j󂳂ĂȂȂ珉Ȃ
buffer_clear_start:
		bsr	initialize_backscroll_buffer
		bset	#BUFINIT_bit,(bitflag-option_flag,a6)
@@:
		bra	next_option

option_k:
		bsr	get_value
		bmi	@f
		cmpa.l	(DEVIO_ENDADR,a5),a3
		bne	@f			ύXς
		subq	#1,d1
		bls	@f			1ȉ

		mulu	#1024,d1
		movea.l	($1c00),a0
		suba.l	d1,a0
		suba.l	a3,a0			a3 = foCXhCo̖
		cmpa.l	#$80000,a0
		bcs	@f
		add.l	d1,(pastbuf_size-option_flag,a6)
		add.l	d1,(DEVIO_ENDADR,a5)
@@
		bra	next_option

option_w:
		bsr	get_value		Jnʒu
		bmi	option_w_end

		move	d1,d2
		moveq	#0,d1
		cmpi.b	#',',(a2)
		bne	@f

		addq.l	#1,a2
		bsr	get_value		s
		bmi	option_w_end
@@:
		cmpi	#4,d2
		bcs	option_w_end		4 ȉ͖
		move	d2,d0
		cmpi	#28,d0
		bcc	option_w_end		28 ȏ͖

		move	d2,(window_line-option_flag,a6)
		bra	@f
option_w_loop:
		move	(down_line,pc),d0
		add	(window_line,pc),d0
		cmpi	#28,d0
		bcc	option_w_end		ԉ܂ōsꍇ

		lea	(text_address,pc),a0
		addi.l	#$800,(a0)+
		addi	#$404,(a0)+
		addq	#1,(a0)
@@:
		dbra	d1,option_w_loop
option_w_end:
		bra	next_option

print_hexadecimal:
		lea	(str_buf,pc),a1
print_hex_loop:
		moveq	#$f,d0
		and	d1,d0
		addi	#'0',d0
		cmpi	#'9',d0
		bls	@f
		addq	#'A'-'0'-10,d0
@@
		move.b	d0,-(a1)
		lsr.l	#4,d1
		bne	print_hex_loop
		jmp	(a3)			print

print_kiro_decimal:
		lea	(str_buf,pc),a1
		moveq	#10,d0
		lsr.l	d0,d1			KBPʂɂ
@@
		divu	d0,d1
		swap	d1
		addi	#'0',d1
		move.b	d1,-(a1)
		clr	d1
		swap	d1
		bne	@b
		jmp	(a3)			print

* l
get_value:
		bsr	is_number
		move	d0,d1
		bpl	@f
*		moveq	#-1,d0
		rts
get_value_loop:
		mulu	#10,d1
		add	d0,d1
@@
		bsr	is_number
		bpl	get_value_loop
		moveq	#0,d0
		rts

is_number:
		move.b	(a2)+,d0
		subi.b	#'0',d0
		cmpi.b	#9,d0
		bhi	@f

		ext	d0
		rts
@@:
		subq.l	#1,a2
		moveq	#-1,d0
		rts

command_exec:
		DOS	_EXIT

* Data Section -------------------------------- *

		.data				xcon_initƗ̈ɎgpׁA
		.even				Ȃׂ̕ɔj󂳂Ă̂u
title_mes:
		.dc.b	CR,LF
		.dc.b	'Console driver v',version
		.ifdef	__EMACS
			.dc.b	'[em]'
		.endif
		.dc.b	' / (C)1990 ږā ,',date,' Ԃq.',CR,LF
str_buf:	.dc.b	0
xcon_filename:	.dc.b	'XCON',0

double_include_err_mes:
		.dc.b	'hCo͊ɓo^Ă܂.',CR,LF,0
no_buf_err_mes:
		.dc.b	'obNXN[obt@̗eʂw肳Ă܂.',CR,LF,0
no_mem_err_mes:
		.dc.b	'܂.',CR,LF,0

initmes1:	.dc.b	'obNXN[obt@($',0
initmes2:	.dc.b	'K)͏܂.',CR,LF,0
initmes3:	.dc.b	'K)܂.',CR,LF,0
initmes4:	.dc.b	'L[{[hobt@($',0
initmes5:	.dc.b	'K)mۂ܂.',CR,LF,0

option_o_list:	.dc.b	'21cs'
option_n_list:	.dc.b	'bcet'

* 㑤͔j\ȕ -------------- *

condrv_pal:	.dc.b	'CONDRV.PAL',0

search_forward_mes:
		.dc.b	' O:',0
search_backward_mes:
		.dc.b	' :',0
searching_mes:
		.dc.b	'',0
not_found_mes:
		.dc.b	'܂',0
iearch_mes_1:
		.dc.b	'isearch [',0
iearch_mes_2:
		.dc.b	']:',0


write_file_prompt:
		.dc.b	' t@Co:',0
insert_file_prompt:
		.dc.b	' t@Cǂݍ:',0
disk_notready_mes:
		.dc.b	'fBXN}ł',0
		.even
file_io_disable_mes:
		.dc	0
		.dc.b	'͕s\ȃfoCXł',0

fopen_err_mes_tbl:
		.dc.b	$fe,'t@C݂܂',0
		.dc.b	$fd,'fBNg݂܂',0
		.dc.b	$fc,'FCB sĂ܂',0
		.dc.b	$fb,'fBNg/{[x̓I[vo܂',0
		.dc.b	$f3,'t@Cُł',0
		.dc.b	$f1,'hCuُł',0
		.dc.b	$ed,'ݕs\ȃt@Cł',0
		.dc.b	$e9,'fBXN̗eʂsĂ܂',0
		.dc.b	$e8,'fBNgɋ󂫂܂',0
		.dc.b	$df,'t@CbNĂ܂',0
		.dc.b	$dd,'V{bNÑlXg[܂',0
fopen_err_mes:	.dc.b	$00,'t@CI[vo܂(̑̃G[)',0

toggle_buffer_mode_mes:
		.dc.b	'ݒύX(B:BS C:L폜 E:ESC폜 I:TABϊ T:Tab\ R:s\ X:[h):',0
toggle_text_mode_mes:
		.dc.b	'ݒύX(1:}EX 2:eLXgۑ 3:eLXggp󋵖):',0
set_mark_mes:
		.dc.b	'set-mark.',0


		.ifndef	__EMACS
define_label_mes:
		.dc.b	'x`(',0
jump_label_mes:
		.dc.b	'xWv(',0
label_mes_end:
		.dc.b	'):',0
		.endif

		.ifdef	__EMACS
no_mark_err_mes:
		.dc.b	'}[Nݒ肳Ă܂',0

prefix_meta_mes:	.dc.b	'Meta',0
prefix_ctrlx_mes:	.dc.b	'C-x',0

ise_fnc_tbl:
		.dc.b	21,$ff,1,0		ROLL UP
		.dc.b	22,$ff,2,0		ROLL DOWN
		.dc.b	24,$ff,3,0		DEL
		.dc.b	25,$ff,4,0		
		.dc.b	26,$ff,5,0		
		.dc.b	27,$ff,6,0		
		.dc.b	28,$ff,7,0		
		.dc.b	29,$ff,8,0		CLR
		.dc.b	30,$ff,9,0		HELP
		.dc.b	31,$ff,10,0		HOME
		.dc.b	32,$ff,11,0		UNDO
		.dc.b	0

		.endif

* lf[^ ---------------------------------

		.quad

text_address:	.dc.l	$e60400			;obNXN[EBhE̍AhX
text_ras_no:	.dc	$202			;X^ԍ
down_line:	.dc	0			;Ɉړs
window_line:	.dc	28			;obNXN[EBhE̍s-1

tab_font_1:	.dc.b	0,0,0,0,0,0,0,0		TAB JntHg(ʏ͕s)
		.dc.b	$20,$30,$38,$3c		*,0,0,0,0

tab_font_2:	.dc.b	0,0,0,0,0,0,0,0		TAB tHg(ʏ͕s)
		.dc.b	0,0,0,$10		*,0,0,0,0
nul_string:
cr_font:	.dc.b	0,0,0,0,0,0,0,0		stHg
		.dc.b	$38,$38,$3e,$3c,$38,$30,0,0

putbuf_column:	.dc.b	WIDTH			;obt@

default_past_header:
		.dc.b	'>'
option_f_col:	.dc.b	3			;IOCS _B_PUTMES ̐F
option_o_flag:	.dc.b	2

ctrl2scan_table:
		.irpc	%a,ABCDEFGHIJKLMNOPQRSTUVWXYZm_nO_@Ihfij{C|D^0123456789FGH
		.dc.b	KEY_%a
		.endm

* wv ---------------------------------------
help_mes_top:
		.dc.b	0
		.ifdef	__EMACS
			.include	condrv_help_em.s
		.else
			.include	condrv_help.s
		.endif
help_mes_last_ofst:
		.dc.b	0			Ō̍s̒ 0 oCg
help_mes_last_ptr:
		.dc.b	0			s
help_mes_end:
*		.dc.b	0			Ō̍s̒ ̂Q(ȂĂC낤...

		.quad
help_buf_struct:
*		.dc.l	'hmk*'
		.dc.l	help_mes_top		obt@擪
		.dc.l	help_mes_top		Oobt@̐擪
		.dc.l	help_mes_last_ofst	ݍs̐擪
		.dc.l	help_mes_last_ptr	݃|C^
		.dc.l	help_mes_end+1		obt@+1
*		.ds.l	2

HOOKTBL:	.macro	funcno,newadr
		.dc	BASE+.low.funcno*4,newadr-top_
		.endm

* xN^ύX郊Xg -----------------------
* gp̓O[hŌ̃AhXҔ
		.quad
hook_table_top:

BASE:		.set	$400
b_keyinp_orig:	HOOKTBL	_B_KEYINP	,iocs_b_keyinp
b_keysns_orig:	HOOKTBL	_B_KEYSNS	,iocs_b_keysns
key_init_orig:	HOOKTBL	_KEY_INIT	,iocs_key_init
b_putc_orig:	HOOKTBL	_B_PUTC		,iocs_b_putc
b_print_orig:	HOOKTBL	_B_PRINT	,iocs_b_print
txrascpy_orig:	HOOKTBL	_TXRASCPY	,iocs_txrascpy

BASE:		.set	$1800
hendsp_orig:	HOOKTBL	_HENDSP		,dos_hendsp
fnckey_orig:	HOOKTBL	_FNCKEY		,dos_fnckey
conctrl_orig:	HOOKTBL	_CONCTRL	,dos_conctrl

		.dc	0		* end of table

* Block Storage Section ----------------------- *

		.bss
		.quad

		.ifndef	__EMACS
label_buffer:	.ds.l	26
		.endif
xcon_req_adr:	.ds.l	1
		.ifdef	__XCONC
xconc_req_adr:	.ds.l	1
		.endif

fepctrl_lock:	.ds.l	1
fepctrl_mode:	.ds.l	1
last_time:	.ds.l	1
mes_end_adr:	.ds.l	1
io_buffer:
fnckey_buf:
line_store_buf:	.ds.b	TEXTSAVESIZE	š͎̃eLXgۑobt@
case_table:	.ds.b	256		p->啶ϊe[u
search_string:	.ds.b	GETSMAX+1	啶(2ڈȍ~)
ctype_table:	.ds.b	256

sys_stat_prtbuf:
		.ds.b	1			'!'\pobt@
past_header:
		.ds.b	1
search_string_buf:
		.ds.b	GETSMAX+1		obt@
isearch_string_buf:
		.ds.b	GETSMAX+1

		.even
cursor_blink_count:
		.ds.b	1
cursor_blink_state:
		.ds.b	1
iocs_curflg:
		.ds.b	2			IOCSworkҔbuffer($992-$993:_OS_CURON/OFF)
bitflag:
		.ds.b	1			etO
HELPMODE_bit:	.equ	7 : wv[h
AFTERCR_bit:	.equ	6 : s:y[Xgwb_o͗p
FEPOPEN_bit:	.equ	5 : ϊI[v
GETSS_bit:	.equ	4 : s͒
NO_FUNC_bit:	.equ	3 : t@NVL[""\("!>"\s\tO)
SUSPEND_bit:	.equ	2 : obNXN[ʂJ܂܏I
BUFINIT_bit:	.equ	1 : obt@ς:gݍݎ"`܂"\p
BACKSCR_bit:	.equ	0 : obNXN[[h
IS_HELPMODE:	.equ	%1000_0000
IS_AFTERCR:	.equ	%0100_0000
IS_FEPOPEN:	.equ	%0010_0000
IS_GETSS:	.equ	%0001_0000
IS_NO_FUNC:	.equ	%0000_1000
IS_SUSPEND:	.equ	%0000_0100
IS_BUFINIT:	.equ	%0000_0010
IS_BACKSCR:	.equ	%0000_0001

		.quad
text_pal_buff:	.ds	16			eLXgpbgҔobt@

vdisp_int_adr:	.ds.l	1			荞݂ŃtbNAhX
ras_int_adr:	.ds.l	1			X^荞݂ŃtbNAhX

line_buf:	.ds.l	29			\̍s̃obt@AhX
buffer_size:	.ds.l	1			obt@e-32bytes(Ǘ̕)

mark_char_adr:	.ds.l	1			}[NJnʒu???
mark_line_adr:	.ds.l	1			}[NJns̃obt@AhX

cursorX:	.ds	1			obNÕJ[\wW
cursorXbyte:	.ds	1			obNO̍s̍[̃oCg
cursorY:	.ds	1			obNÕJ[\xW

xcon_output_hb:	.ds	1			XCON ւ̏o:2oCg̏(ʃoCg͖)

bufwrite_last:	.ds	1			Ȍݕ
bufmod_stack:	.dc.l	1
bufmod_height:	.ds.b	1
no_mem_flag:
gm_automask:	.ds.b	1
gm_maskflag:	.ds.b	1
ms_ctrl_flag:	.ds.b	1			}EX-1
skeymod_save:	.ds.b	1			ȑÕ\tgL[{[h
mscur_on_flag:	.ds.b	1			}EXJ[\-1(ŕ\)
prefix_flag:				*	.ifdef	__EMACS
ins_clr_flag:	.ds.b	1		*	.ifndef __EMACS
isearch_flag:	.ds.b	1

option_m_flag:	.ds.b	1	bit2=1:TUSEMD | bit1=1:Plane2/3ۑ | bit0=1:Mouse
option_p_flag:	.ds.b	1
option_r_flag:	.ds.b	1
option_t_flag:	.ds.b	1
option_x_flag:	.ds.b	1

option_nb_flag:	.ds.b	1
option_nc_flag:	.ds.b	1
option_ne_flag:	.ds.b	1
option_nt_flag:	.ds.b	1

		.quad
past_pointer:
		.ds.l	1		y[Xgʒu
backscroll_buf_adr:
		.ds.l	1		obt@擪AhX
keypast_buffer:
		.ds.b	KBbuf_Default

end_:
		.end	command_exec

# J[N̍\
	.dc.b	-j(bit7),-f(bit0) tO
	.dc.b	0			.even???
	.dc	y[Xg̃EFCgJE^
	.dc		V	l
	.dc.l	VXeR[̃AhX
	.dc.b	0			gp???
	.dc.b	EBhEL[}tO(-1:})
	.dc.l	obt@݃[`̃AhX
	.dc.l	L[{[hobt@̒
	.dc.l	L[{[hobt@̐擪AhX
	.dc.l	ʎq'hmk*'
* IOCS _KEY_INIT

# L[{[hobt@ӂ̍\
	.dc.l	y[XgJnAhX
	.dc.l	obNOobt@̃AhX
* y[Xgobt@

* End of File -------------------------------- *
